searchData={"items":[{"type":"module","title":"Kayrock","doc":"Documentation for Kayrock.","ref":"Kayrock.html"},{"type":"function","title":"Kayrock.api_versions/3","doc":"Fetch the supported API versions from the cluster\n\nKayrock currently supports versions 0 and 1.\n\n[ApiVersions](https://kafka.apache.org/protocol.html#The_Messages_ApiVersions)","ref":"Kayrock.html#api_versions/3"},{"type":"function","title":"Kayrock.broker_sync_call/2","doc":"Makes a synchronous call directly to a broker\n\n`broker_id` should be the pid of a `Kayrock.BrokerConnection`.  `request` must\nhave an implementation for the `Kayrock.Request` protocol.","ref":"Kayrock.html#broker_sync_call/2"},{"type":"function","title":"Kayrock.client_call/3","doc":"Make an api call to a Kafka cluster mediated through a client","ref":"Kayrock.html#client_call/3"},{"type":"function","title":"Kayrock.create_topics/5","doc":"Create one or more topics","ref":"Kayrock.html#create_topics/5"},{"type":"function","title":"Kayrock.delete_topics/5","doc":"","ref":"Kayrock.html#delete_topics/5"},{"type":"function","title":"Kayrock.fetch/4","doc":"","ref":"Kayrock.html#fetch/4"},{"type":"function","title":"Kayrock.produce/6","doc":"","ref":"Kayrock.html#produce/6"},{"type":"function","title":"Kayrock.topics_metadata/2","doc":"","ref":"Kayrock.html#topics_metadata/2"},{"type":"type","title":"Kayrock.api_response/0","doc":"Represents an API response message\n\nThis will generally be a generated struct.","ref":"Kayrock.html#t:api_response/0"},{"type":"type","title":"Kayrock.api_version/0","doc":"Specifies the version of an API message\n\nKayrock will generally try to pick a reasonable default here, but you can\noverride it in many cases.  See [Kafka Protocol Documentation](https://kafka.apache.org/protocol.html#The_Messages_Metadata)","ref":"Kayrock.html#t:api_version/0"},{"type":"type","title":"Kayrock.broker_pid/0","doc":"A `pid` for a `Kayrock.BrokerConnection` process.\n\nThis is for low-level communication with individual brokers.  Generally you\nshould work with a `client_pid`.","ref":"Kayrock.html#t:broker_pid/0"},{"type":"type","title":"Kayrock.client_pid/0","doc":"A `pid` for a `Kayrock.Client` process.","ref":"Kayrock.html#t:client_pid/0"},{"type":"type","title":"Kayrock.node_id/0","doc":"A broker's advertised integer node id","ref":"Kayrock.html#t:node_id/0"},{"type":"type","title":"Kayrock.node_selector/0","doc":"A node selector for sending messages to the cluster\n\nGenerally the Kayrock API will select the right node depending on the\noperation.  These are exposed to provide fine-grained user control in a few\ncases where it might make sense to override the default.\n\nPossible values:\n* Integer - Directly access a node by id.  Generally you should not do this\n  unless you are operating at a low level.\n* `:random` - Select a node at random from the cluster metadata.\n* `:controller` - Select the controller node - this is used for cluster\n  management messages","ref":"Kayrock.html#t:node_selector/0"},{"type":"type","title":"Kayrock.partition_id/0","doc":"","ref":"Kayrock.html#t:partition_id/0"},{"type":"type","title":"Kayrock.topic_name/0","doc":"","ref":"Kayrock.html#t:topic_name/0"},{"type":"module","title":"Kayrock.AddOffsetsToTxn","doc":"Kayrock-generated module for the Kafka `add_offsets_to_txn` API","ref":"Kayrock.AddOffsetsToTxn.html"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.AddOffsetsToTxn.html#deserialize/2"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.AddOffsetsToTxn.html#get_request_struct/1"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.AddOffsetsToTxn.html#max_vsn/0"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.AddOffsetsToTxn.html#min_vsn/0"},{"type":"type","title":"Kayrock.AddOffsetsToTxn.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.AddOffsetsToTxn.html#t:request_t/0"},{"type":"type","title":"Kayrock.AddOffsetsToTxn.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.AddOffsetsToTxn.html#t:response_t/0"},{"type":"module","title":"Kayrock.AddOffsetsToTxn.V0.Request","doc":"Kayrock-generated request struct for Kafka `add_offsets_to_txn` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  transactional_id: :string,\n  producer_id: :int64,\n  producer_epoch: :int16,\n  group_id: :string\n]\n```","ref":"Kayrock.AddOffsetsToTxn.V0.Request.html"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.AddOffsetsToTxn.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.AddOffsetsToTxn.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.AddOffsetsToTxn.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.AddOffsetsToTxn.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.AddOffsetsToTxn.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.AddOffsetsToTxn.V0.Request.t/0","doc":"Request struct for the Kafka `add_offsets_to_txn` API v0","ref":"Kayrock.AddOffsetsToTxn.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.AddOffsetsToTxn.V0.Response","doc":"Kayrock-generated response struct for Kafka `add_offsets_to_txn` v0 API\nmessages\n\nThe schema of this API is\n```\n[throttle_time_ms: :int32, error_code: :int16]\n```","ref":"Kayrock.AddOffsetsToTxn.V0.Response.html"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.AddOffsetsToTxn.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.AddOffsetsToTxn.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.AddOffsetsToTxn.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.AddOffsetsToTxn.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.AddOffsetsToTxn.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.AddOffsetsToTxn.V0.Response.t/0","doc":"Response struct for the Kafka `add_offsets_to_txn` API v0","ref":"Kayrock.AddOffsetsToTxn.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.AddPartitionsToTxn","doc":"Kayrock-generated module for the Kafka `add_partitions_to_txn` API","ref":"Kayrock.AddPartitionsToTxn.html"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.AddPartitionsToTxn.html#deserialize/2"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.AddPartitionsToTxn.html#get_request_struct/1"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.AddPartitionsToTxn.html#max_vsn/0"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.AddPartitionsToTxn.html#min_vsn/0"},{"type":"type","title":"Kayrock.AddPartitionsToTxn.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.AddPartitionsToTxn.html#t:request_t/0"},{"type":"type","title":"Kayrock.AddPartitionsToTxn.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.AddPartitionsToTxn.html#t:response_t/0"},{"type":"module","title":"Kayrock.AddPartitionsToTxn.V0.Request","doc":"Kayrock-generated request struct for Kafka `add_partitions_to_txn` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  transactional_id: :string,\n  producer_id: :int64,\n  producer_epoch: :int16,\n  topics: {:array, [topic: :string, partitions: {:array, :int32}]}\n]\n```","ref":"Kayrock.AddPartitionsToTxn.V0.Request.html"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.AddPartitionsToTxn.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.AddPartitionsToTxn.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.AddPartitionsToTxn.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.AddPartitionsToTxn.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.AddPartitionsToTxn.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.AddPartitionsToTxn.V0.Request.t/0","doc":"Request struct for the Kafka `add_partitions_to_txn` API v0","ref":"Kayrock.AddPartitionsToTxn.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.AddPartitionsToTxn.V0.Response","doc":"Kayrock-generated response struct for Kafka `add_partitions_to_txn` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  errors: {:array,\n   [\n     topic: :string,\n     partition_errors: {:array, [partition: :int32, error_code: :int16]}\n   ]}\n]\n```","ref":"Kayrock.AddPartitionsToTxn.V0.Response.html"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.AddPartitionsToTxn.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.AddPartitionsToTxn.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.AddPartitionsToTxn.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.AddPartitionsToTxn.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.AddPartitionsToTxn.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.AddPartitionsToTxn.V0.Response.t/0","doc":"Response struct for the Kafka `add_partitions_to_txn` API v0","ref":"Kayrock.AddPartitionsToTxn.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.AlterConfigs","doc":"Kayrock-generated module for the Kafka `alter_configs` API","ref":"Kayrock.AlterConfigs.html"},{"type":"function","title":"Kayrock.AlterConfigs.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.AlterConfigs.html#deserialize/2"},{"type":"function","title":"Kayrock.AlterConfigs.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.AlterConfigs.html#get_request_struct/1"},{"type":"function","title":"Kayrock.AlterConfigs.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.AlterConfigs.html#max_vsn/0"},{"type":"function","title":"Kayrock.AlterConfigs.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.AlterConfigs.html#min_vsn/0"},{"type":"type","title":"Kayrock.AlterConfigs.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.AlterConfigs.html#t:request_t/0"},{"type":"type","title":"Kayrock.AlterConfigs.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.AlterConfigs.html#t:response_t/0"},{"type":"module","title":"Kayrock.AlterConfigs.V0.Request","doc":"Kayrock-generated request struct for Kafka `alter_configs` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  resources: {:array,\n   [\n     resource_type: :int8,\n     resource_name: :string,\n     config_entries: {:array,\n      [config_name: :string, config_value: :nullable_string]}\n   ]},\n  validate_only: :boolean\n]\n```","ref":"Kayrock.AlterConfigs.V0.Request.html"},{"type":"function","title":"Kayrock.AlterConfigs.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.AlterConfigs.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.AlterConfigs.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.AlterConfigs.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.AlterConfigs.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.AlterConfigs.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.AlterConfigs.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.AlterConfigs.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.AlterConfigs.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.AlterConfigs.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.AlterConfigs.V0.Request.t/0","doc":"Request struct for the Kafka `alter_configs` API v0","ref":"Kayrock.AlterConfigs.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.AlterConfigs.V0.Response","doc":"Kayrock-generated response struct for Kafka `alter_configs` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  resources: {:array,\n   [\n     error_code: :int16,\n     error_message: :nullable_string,\n     resource_type: :int8,\n     resource_name: :string\n   ]}\n]\n```","ref":"Kayrock.AlterConfigs.V0.Response.html"},{"type":"function","title":"Kayrock.AlterConfigs.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.AlterConfigs.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.AlterConfigs.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.AlterConfigs.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.AlterConfigs.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.AlterConfigs.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.AlterConfigs.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.AlterConfigs.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.AlterConfigs.V0.Response.t/0","doc":"Response struct for the Kafka `alter_configs` API v0","ref":"Kayrock.AlterConfigs.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.AlterReplicaLogDirs","doc":"Kayrock-generated module for the Kafka `alter_replica_log_dirs` API","ref":"Kayrock.AlterReplicaLogDirs.html"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.AlterReplicaLogDirs.html#deserialize/2"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.AlterReplicaLogDirs.html#get_request_struct/1"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.AlterReplicaLogDirs.html#max_vsn/0"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.AlterReplicaLogDirs.html#min_vsn/0"},{"type":"type","title":"Kayrock.AlterReplicaLogDirs.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.AlterReplicaLogDirs.html#t:request_t/0"},{"type":"type","title":"Kayrock.AlterReplicaLogDirs.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.AlterReplicaLogDirs.html#t:response_t/0"},{"type":"module","title":"Kayrock.AlterReplicaLogDirs.V0.Request","doc":"Kayrock-generated request struct for Kafka `alter_replica_log_dirs` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  log_dirs: {:array,\n   [\n     log_dir: :string,\n     topics: {:array, [topic: :string, partitions: {:array, :int32}]}\n   ]}\n]\n```","ref":"Kayrock.AlterReplicaLogDirs.V0.Request.html"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.AlterReplicaLogDirs.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.AlterReplicaLogDirs.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.AlterReplicaLogDirs.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.AlterReplicaLogDirs.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.AlterReplicaLogDirs.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.AlterReplicaLogDirs.V0.Request.t/0","doc":"Request struct for the Kafka `alter_replica_log_dirs` API v0","ref":"Kayrock.AlterReplicaLogDirs.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.AlterReplicaLogDirs.V0.Response","doc":"Kayrock-generated response struct for Kafka `alter_replica_log_dirs` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array, [partition: :int32, error_code: :int16]}\n   ]}\n]\n```","ref":"Kayrock.AlterReplicaLogDirs.V0.Response.html"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.AlterReplicaLogDirs.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.AlterReplicaLogDirs.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.AlterReplicaLogDirs.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.AlterReplicaLogDirs.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.AlterReplicaLogDirs.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.AlterReplicaLogDirs.V0.Response.t/0","doc":"Response struct for the Kafka `alter_replica_log_dirs` API v0","ref":"Kayrock.AlterReplicaLogDirs.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.ApiVersions","doc":"Kayrock-generated module for the Kafka `api_versions` API","ref":"Kayrock.ApiVersions.html"},{"type":"function","title":"Kayrock.ApiVersions.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.ApiVersions.html#deserialize/2"},{"type":"function","title":"Kayrock.ApiVersions.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.ApiVersions.html#get_request_struct/1"},{"type":"function","title":"Kayrock.ApiVersions.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (1)","ref":"Kayrock.ApiVersions.html#max_vsn/0"},{"type":"function","title":"Kayrock.ApiVersions.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.ApiVersions.html#min_vsn/0"},{"type":"type","title":"Kayrock.ApiVersions.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.ApiVersions.html#t:request_t/0"},{"type":"type","title":"Kayrock.ApiVersions.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.ApiVersions.html#t:response_t/0"},{"type":"module","title":"Kayrock.ApiVersions.V0.Request","doc":"Kayrock-generated request struct for Kafka `api_versions` v0 API\nmessages\n\nThe schema of this API is\n```\n[]\n```","ref":"Kayrock.ApiVersions.V0.Request.html"},{"type":"function","title":"Kayrock.ApiVersions.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ApiVersions.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.ApiVersions.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.ApiVersions.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.ApiVersions.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.ApiVersions.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.ApiVersions.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ApiVersions.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.ApiVersions.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.ApiVersions.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.ApiVersions.V0.Request.t/0","doc":"Request struct for the Kafka `api_versions` API v0","ref":"Kayrock.ApiVersions.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.ApiVersions.V0.Response","doc":"Kayrock-generated response struct for Kafka `api_versions` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  error_code: :int16,\n  api_versions: {:array,\n   [api_key: :int16, min_version: :int16, max_version: :int16]}\n]\n```","ref":"Kayrock.ApiVersions.V0.Response.html"},{"type":"function","title":"Kayrock.ApiVersions.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ApiVersions.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.ApiVersions.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.ApiVersions.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.ApiVersions.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.ApiVersions.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.ApiVersions.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ApiVersions.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.ApiVersions.V0.Response.t/0","doc":"Response struct for the Kafka `api_versions` API v0","ref":"Kayrock.ApiVersions.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.ApiVersions.V1.Request","doc":"Kayrock-generated request struct for Kafka `api_versions` v1 API\nmessages\n\nThe schema of this API is\n```\n[]\n```","ref":"Kayrock.ApiVersions.V1.Request.html"},{"type":"function","title":"Kayrock.ApiVersions.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ApiVersions.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.ApiVersions.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.ApiVersions.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.ApiVersions.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.ApiVersions.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.ApiVersions.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ApiVersions.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.ApiVersions.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.ApiVersions.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.ApiVersions.V1.Request.t/0","doc":"Request struct for the Kafka `api_versions` API v1","ref":"Kayrock.ApiVersions.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.ApiVersions.V1.Response","doc":"Kayrock-generated response struct for Kafka `api_versions` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  error_code: :int16,\n  api_versions: {:array,\n   [api_key: :int16, min_version: :int16, max_version: :int16]},\n  throttle_time_ms: :int32\n]\n```","ref":"Kayrock.ApiVersions.V1.Response.html"},{"type":"function","title":"Kayrock.ApiVersions.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ApiVersions.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.ApiVersions.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.ApiVersions.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.ApiVersions.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.ApiVersions.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.ApiVersions.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ApiVersions.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.ApiVersions.V1.Response.t/0","doc":"Response struct for the Kafka `api_versions` API v1","ref":"Kayrock.ApiVersions.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.BrokerConnection","doc":"A connection to a kafka broker.\n\nImplements the [Connection](https://github.com/fishcakez/connection/)\nbehavior.\n\nYou shouldn't generally need to use this module directly.  Use `Kayrock` or\n`Kayrock.Client`.","ref":"Kayrock.BrokerConnection.html"},{"type":"function","title":"Kayrock.BrokerConnection.close/1","doc":"","ref":"Kayrock.BrokerConnection.html#close/1"},{"type":"function","title":"Kayrock.BrokerConnection.recv/2","doc":"","ref":"Kayrock.BrokerConnection.html#recv/2"},{"type":"function","title":"Kayrock.BrokerConnection.send/2","doc":"","ref":"Kayrock.BrokerConnection.html#send/2"},{"type":"function","title":"Kayrock.BrokerConnection.start_link/4","doc":"","ref":"Kayrock.BrokerConnection.html#start_link/4"},{"type":"function","title":"Kayrock.BrokerConnection.stop/1","doc":"","ref":"Kayrock.BrokerConnection.html#stop/1"},{"type":"module","title":"Kayrock.Client","doc":"Manages communication with a single cluster","ref":"Kayrock.Client.html"},{"type":"function","title":"Kayrock.Client.broker_call/3","doc":"","ref":"Kayrock.Client.html#broker_call/3"},{"type":"function","title":"Kayrock.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Kayrock.Client.html#child_spec/1"},{"type":"function","title":"Kayrock.Client.cluster_metadata/1","doc":"","ref":"Kayrock.Client.html#cluster_metadata/1"},{"type":"function","title":"Kayrock.Client.start_link/2","doc":"","ref":"Kayrock.Client.html#start_link/2"},{"type":"function","title":"Kayrock.Client.stop/1","doc":"","ref":"Kayrock.Client.html#stop/1"},{"type":"module","title":"Kayrock.Client.ClusterMetadata","doc":"Encapsulates what we know about the state of a Kafka broker cluster","ref":"Kayrock.Client.ClusterMetadata.html"},{"type":"function","title":"Kayrock.Client.ClusterMetadata.broker_by_node_id/2","doc":"","ref":"Kayrock.Client.ClusterMetadata.html#broker_by_node_id/2"},{"type":"function","title":"Kayrock.Client.ClusterMetadata.from_metadata_v1_response/1","doc":"","ref":"Kayrock.Client.ClusterMetadata.html#from_metadata_v1_response/1"},{"type":"function","title":"Kayrock.Client.ClusterMetadata.get_and_update_broker/3","doc":"","ref":"Kayrock.Client.ClusterMetadata.html#get_and_update_broker/3"},{"type":"function","title":"Kayrock.Client.ClusterMetadata.known_topics/1","doc":"","ref":"Kayrock.Client.ClusterMetadata.html#known_topics/1"},{"type":"function","title":"Kayrock.Client.ClusterMetadata.merge_brokers/2","doc":"","ref":"Kayrock.Client.ClusterMetadata.html#merge_brokers/2"},{"type":"function","title":"Kayrock.Client.ClusterMetadata.select_node/2","doc":"","ref":"Kayrock.Client.ClusterMetadata.html#select_node/2"},{"type":"type","title":"Kayrock.Client.ClusterMetadata.node_select_error/0","doc":"","ref":"Kayrock.Client.ClusterMetadata.html#t:node_select_error/0"},{"type":"type","title":"Kayrock.Client.ClusterMetadata.t/0","doc":"","ref":"Kayrock.Client.ClusterMetadata.html#t:t/0"},{"type":"module","title":"Kayrock.Compression","doc":"Handles compression/decompression of messages.\n\nNOTE this is a copy of KafkaEx.Compression:\nhttps://github.com/kafkaex/kafka_ex/blob/master/lib/kafka_ex/compression.ex\n\nIt is duplicated here to avoid creating a circular dependency.\n\nSee https://cwiki.apache.org/confluence/display/KAFKA/A+Guide+To+The+Kafka+Protocol#AGuideToTheKafkaProtocol-Compression\n\nTo add new compression types:\n\n1. Add the appropriate dependency to mix.exs (don't forget to add it\nto the application list).\n2. Add the appropriate attribute value and compression_type atom.\n3. Add a decompress function clause.\n4. Add a compress function clause.","ref":"Kayrock.Compression.html"},{"type":"function","title":"Kayrock.Compression.compress/2","doc":"This function should pattern match on the compression_type atom and\nreturn the compressed data as well as the corresponding attribute\nvalue.","ref":"Kayrock.Compression.html#compress/2"},{"type":"function","title":"Kayrock.Compression.decompress/2","doc":"This function should pattern match on the attribute value and return\nthe decompressed data.","ref":"Kayrock.Compression.html#decompress/2"},{"type":"function","title":"Kayrock.Compression.snappy_decompress_chunk/2","doc":"","ref":"Kayrock.Compression.html#snappy_decompress_chunk/2"},{"type":"type","title":"Kayrock.Compression.attribute_t/0","doc":"","ref":"Kayrock.Compression.html#t:attribute_t/0"},{"type":"type","title":"Kayrock.Compression.compression_type_t/0","doc":"","ref":"Kayrock.Compression.html#t:compression_type_t/0"},{"type":"module","title":"Kayrock.Convenience","doc":"Convenience functions for working with Kayrock / Kafka API data","ref":"Kayrock.Convenience.html"},{"type":"function","title":"Kayrock.Convenience.get_partition_leaders/2","doc":"","ref":"Kayrock.Convenience.html#get_partition_leaders/2"},{"type":"function","title":"Kayrock.Convenience.partition_last_offset/3","doc":"","ref":"Kayrock.Convenience.html#partition_last_offset/3"},{"type":"function","title":"Kayrock.Convenience.partitions_last_offset/3","doc":"Returns a map of partition to offset for partitions on the same leader\n\nAll partitions must be on the same leader or you will get -1 for the offset","ref":"Kayrock.Convenience.html#partitions_last_offset/3"},{"type":"function","title":"Kayrock.Convenience.topic_exists?/2","doc":"","ref":"Kayrock.Convenience.html#topic_exists?/2"},{"type":"function","title":"Kayrock.Convenience.topic_last_offsets/2","doc":"","ref":"Kayrock.Convenience.html#topic_last_offsets/2"},{"type":"module","title":"Kayrock.CreateAcls","doc":"Kayrock-generated module for the Kafka `create_acls` API","ref":"Kayrock.CreateAcls.html"},{"type":"function","title":"Kayrock.CreateAcls.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.CreateAcls.html#deserialize/2"},{"type":"function","title":"Kayrock.CreateAcls.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.CreateAcls.html#get_request_struct/1"},{"type":"function","title":"Kayrock.CreateAcls.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.CreateAcls.html#max_vsn/0"},{"type":"function","title":"Kayrock.CreateAcls.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.CreateAcls.html#min_vsn/0"},{"type":"type","title":"Kayrock.CreateAcls.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.CreateAcls.html#t:request_t/0"},{"type":"type","title":"Kayrock.CreateAcls.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.CreateAcls.html#t:response_t/0"},{"type":"module","title":"Kayrock.CreateAcls.V0.Request","doc":"Kayrock-generated request struct for Kafka `create_acls` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  creations: {:array,\n   [\n     resource_type: :int8,\n     resource_name: :string,\n     principal: :string,\n     host: :string,\n     operation: :int8,\n     permission_type: :int8\n   ]}\n]\n```","ref":"Kayrock.CreateAcls.V0.Request.html"},{"type":"function","title":"Kayrock.CreateAcls.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreateAcls.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.CreateAcls.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.CreateAcls.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreateAcls.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.CreateAcls.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.CreateAcls.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreateAcls.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.CreateAcls.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.CreateAcls.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.CreateAcls.V0.Request.t/0","doc":"Request struct for the Kafka `create_acls` API v0","ref":"Kayrock.CreateAcls.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.CreateAcls.V0.Response","doc":"Kayrock-generated response struct for Kafka `create_acls` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  creation_responses: {:array,\n   [error_code: :int16, error_message: :nullable_string]}\n]\n```","ref":"Kayrock.CreateAcls.V0.Response.html"},{"type":"function","title":"Kayrock.CreateAcls.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreateAcls.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.CreateAcls.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.CreateAcls.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreateAcls.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.CreateAcls.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.CreateAcls.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreateAcls.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.CreateAcls.V0.Response.t/0","doc":"Response struct for the Kafka `create_acls` API v0","ref":"Kayrock.CreateAcls.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.CreateDelegationToken","doc":"Kayrock-generated module for the Kafka `create_delegation_token` API","ref":"Kayrock.CreateDelegationToken.html"},{"type":"function","title":"Kayrock.CreateDelegationToken.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.CreateDelegationToken.html#deserialize/2"},{"type":"function","title":"Kayrock.CreateDelegationToken.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.CreateDelegationToken.html#get_request_struct/1"},{"type":"function","title":"Kayrock.CreateDelegationToken.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.CreateDelegationToken.html#max_vsn/0"},{"type":"function","title":"Kayrock.CreateDelegationToken.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.CreateDelegationToken.html#min_vsn/0"},{"type":"type","title":"Kayrock.CreateDelegationToken.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.CreateDelegationToken.html#t:request_t/0"},{"type":"type","title":"Kayrock.CreateDelegationToken.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.CreateDelegationToken.html#t:response_t/0"},{"type":"module","title":"Kayrock.CreateDelegationToken.V0.Request","doc":"Kayrock-generated request struct for Kafka `create_delegation_token` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  renewers: {:array, [principal_type: :string, name: :string]},\n  max_life_time: :int64\n]\n```","ref":"Kayrock.CreateDelegationToken.V0.Request.html"},{"type":"function","title":"Kayrock.CreateDelegationToken.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreateDelegationToken.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.CreateDelegationToken.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.CreateDelegationToken.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreateDelegationToken.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.CreateDelegationToken.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.CreateDelegationToken.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreateDelegationToken.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.CreateDelegationToken.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.CreateDelegationToken.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.CreateDelegationToken.V0.Request.t/0","doc":"Request struct for the Kafka `create_delegation_token` API v0","ref":"Kayrock.CreateDelegationToken.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.CreateDelegationToken.V0.Response","doc":"Kayrock-generated response struct for Kafka `create_delegation_token` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  error_code: :int16,\n  owner: [principal_type: :string, name: :string],\n  issue_timestamp: :int64,\n  expiry_timestamp: :int64,\n  max_timestamp: :int64,\n  token_id: :string,\n  hmac: :bytes,\n  throttle_time_ms: :int32\n]\n```","ref":"Kayrock.CreateDelegationToken.V0.Response.html"},{"type":"function","title":"Kayrock.CreateDelegationToken.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreateDelegationToken.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.CreateDelegationToken.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.CreateDelegationToken.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreateDelegationToken.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.CreateDelegationToken.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.CreateDelegationToken.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreateDelegationToken.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.CreateDelegationToken.V0.Response.t/0","doc":"Response struct for the Kafka `create_delegation_token` API v0","ref":"Kayrock.CreateDelegationToken.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.CreatePartitions","doc":"Kayrock-generated module for the Kafka `create_partitions` API","ref":"Kayrock.CreatePartitions.html"},{"type":"function","title":"Kayrock.CreatePartitions.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.CreatePartitions.html#deserialize/2"},{"type":"function","title":"Kayrock.CreatePartitions.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.CreatePartitions.html#get_request_struct/1"},{"type":"function","title":"Kayrock.CreatePartitions.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.CreatePartitions.html#max_vsn/0"},{"type":"function","title":"Kayrock.CreatePartitions.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.CreatePartitions.html#min_vsn/0"},{"type":"type","title":"Kayrock.CreatePartitions.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.CreatePartitions.html#t:request_t/0"},{"type":"type","title":"Kayrock.CreatePartitions.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.CreatePartitions.html#t:response_t/0"},{"type":"module","title":"Kayrock.CreatePartitions.V0.Request","doc":"Kayrock-generated request struct for Kafka `create_partitions` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  topic_partitions: {:array,\n   [\n     topic: :string,\n     new_partitions: [count: :int32, assignment: {:array, {:array, :int32}}]\n   ]},\n  timeout: :int32,\n  validate_only: :boolean\n]\n```","ref":"Kayrock.CreatePartitions.V0.Request.html"},{"type":"function","title":"Kayrock.CreatePartitions.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreatePartitions.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.CreatePartitions.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.CreatePartitions.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreatePartitions.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.CreatePartitions.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.CreatePartitions.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreatePartitions.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.CreatePartitions.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.CreatePartitions.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.CreatePartitions.V0.Request.t/0","doc":"Request struct for the Kafka `create_partitions` API v0","ref":"Kayrock.CreatePartitions.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.CreatePartitions.V0.Response","doc":"Kayrock-generated response struct for Kafka `create_partitions` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  topic_errors: {:array,\n   [topic: :string, error_code: :int16, error_message: :nullable_string]}\n]\n```","ref":"Kayrock.CreatePartitions.V0.Response.html"},{"type":"function","title":"Kayrock.CreatePartitions.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreatePartitions.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.CreatePartitions.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.CreatePartitions.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreatePartitions.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.CreatePartitions.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.CreatePartitions.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreatePartitions.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.CreatePartitions.V0.Response.t/0","doc":"Response struct for the Kafka `create_partitions` API v0","ref":"Kayrock.CreatePartitions.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.CreateTopics","doc":"Kayrock-generated module for the Kafka `create_topics` API","ref":"Kayrock.CreateTopics.html"},{"type":"function","title":"Kayrock.CreateTopics.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.CreateTopics.html#deserialize/2"},{"type":"function","title":"Kayrock.CreateTopics.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.CreateTopics.html#get_request_struct/1"},{"type":"function","title":"Kayrock.CreateTopics.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (2)","ref":"Kayrock.CreateTopics.html#max_vsn/0"},{"type":"function","title":"Kayrock.CreateTopics.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.CreateTopics.html#min_vsn/0"},{"type":"type","title":"Kayrock.CreateTopics.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.CreateTopics.html#t:request_t/0"},{"type":"type","title":"Kayrock.CreateTopics.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.CreateTopics.html#t:response_t/0"},{"type":"module","title":"Kayrock.CreateTopics.V0.Request","doc":"Kayrock-generated request struct for Kafka `create_topics` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  create_topic_requests: {:array,\n   [\n     topic: :string,\n     num_partitions: :int32,\n     replication_factor: :int16,\n     replica_assignment: {:array,\n      [partition: :int32, replicas: {:array, :int32}]},\n     config_entries: {:array,\n      [config_name: :string, config_value: :nullable_string]}\n   ]},\n  timeout: :int32\n]\n```","ref":"Kayrock.CreateTopics.V0.Request.html"},{"type":"function","title":"Kayrock.CreateTopics.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreateTopics.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.CreateTopics.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.CreateTopics.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreateTopics.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.CreateTopics.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.CreateTopics.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreateTopics.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.CreateTopics.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.CreateTopics.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.CreateTopics.V0.Request.t/0","doc":"Request struct for the Kafka `create_topics` API v0","ref":"Kayrock.CreateTopics.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.CreateTopics.V0.Response","doc":"Kayrock-generated response struct for Kafka `create_topics` v0 API\nmessages\n\nThe schema of this API is\n```\n[topic_errors: {:array, [topic: :string, error_code: :int16]}]\n```","ref":"Kayrock.CreateTopics.V0.Response.html"},{"type":"function","title":"Kayrock.CreateTopics.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreateTopics.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.CreateTopics.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.CreateTopics.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreateTopics.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.CreateTopics.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.CreateTopics.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreateTopics.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.CreateTopics.V0.Response.t/0","doc":"Response struct for the Kafka `create_topics` API v0","ref":"Kayrock.CreateTopics.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.CreateTopics.V1.Request","doc":"Kayrock-generated request struct for Kafka `create_topics` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  create_topic_requests: {:array,\n   [\n     topic: :string,\n     num_partitions: :int32,\n     replication_factor: :int16,\n     replica_assignment: {:array,\n      [partition: :int32, replicas: {:array, :int32}]},\n     config_entries: {:array,\n      [config_name: :string, config_value: :nullable_string]}\n   ]},\n  timeout: :int32,\n  validate_only: :boolean\n]\n```","ref":"Kayrock.CreateTopics.V1.Request.html"},{"type":"function","title":"Kayrock.CreateTopics.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreateTopics.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.CreateTopics.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.CreateTopics.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreateTopics.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.CreateTopics.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.CreateTopics.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreateTopics.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.CreateTopics.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.CreateTopics.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.CreateTopics.V1.Request.t/0","doc":"Request struct for the Kafka `create_topics` API v1","ref":"Kayrock.CreateTopics.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.CreateTopics.V1.Response","doc":"Kayrock-generated response struct for Kafka `create_topics` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  topic_errors: {:array,\n   [topic: :string, error_code: :int16, error_message: :nullable_string]}\n]\n```","ref":"Kayrock.CreateTopics.V1.Response.html"},{"type":"function","title":"Kayrock.CreateTopics.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreateTopics.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.CreateTopics.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.CreateTopics.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreateTopics.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.CreateTopics.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.CreateTopics.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreateTopics.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.CreateTopics.V1.Response.t/0","doc":"Response struct for the Kafka `create_topics` API v1","ref":"Kayrock.CreateTopics.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.CreateTopics.V2.Request","doc":"Kayrock-generated request struct for Kafka `create_topics` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  create_topic_requests: {:array,\n   [\n     topic: :string,\n     num_partitions: :int32,\n     replication_factor: :int16,\n     replica_assignment: {:array,\n      [partition: :int32, replicas: {:array, :int32}]},\n     config_entries: {:array,\n      [config_name: :string, config_value: :nullable_string]}\n   ]},\n  timeout: :int32,\n  validate_only: :boolean\n]\n```","ref":"Kayrock.CreateTopics.V2.Request.html"},{"type":"function","title":"Kayrock.CreateTopics.V2.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreateTopics.V2.Request.html#api_key/0"},{"type":"function","title":"Kayrock.CreateTopics.V2.Request.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.CreateTopics.V2.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreateTopics.V2.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.CreateTopics.V2.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.CreateTopics.V2.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreateTopics.V2.Request.html#schema/0"},{"type":"function","title":"Kayrock.CreateTopics.V2.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.CreateTopics.V2.Request.html#serialize/1"},{"type":"type","title":"Kayrock.CreateTopics.V2.Request.t/0","doc":"Request struct for the Kafka `create_topics` API v2","ref":"Kayrock.CreateTopics.V2.Request.html#t:t/0"},{"type":"module","title":"Kayrock.CreateTopics.V2.Response","doc":"Kayrock-generated response struct for Kafka `create_topics` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  topic_errors: {:array,\n   [topic: :string, error_code: :int16, error_message: :nullable_string]}\n]\n```","ref":"Kayrock.CreateTopics.V2.Response.html"},{"type":"function","title":"Kayrock.CreateTopics.V2.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.CreateTopics.V2.Response.html#api_key/0"},{"type":"function","title":"Kayrock.CreateTopics.V2.Response.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.CreateTopics.V2.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.CreateTopics.V2.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.CreateTopics.V2.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.CreateTopics.V2.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.CreateTopics.V2.Response.html#schema/0"},{"type":"type","title":"Kayrock.CreateTopics.V2.Response.t/0","doc":"Response struct for the Kafka `create_topics` API v2","ref":"Kayrock.CreateTopics.V2.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DeleteAcls","doc":"Kayrock-generated module for the Kafka `delete_acls` API","ref":"Kayrock.DeleteAcls.html"},{"type":"function","title":"Kayrock.DeleteAcls.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.DeleteAcls.html#deserialize/2"},{"type":"function","title":"Kayrock.DeleteAcls.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.DeleteAcls.html#get_request_struct/1"},{"type":"function","title":"Kayrock.DeleteAcls.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.DeleteAcls.html#max_vsn/0"},{"type":"function","title":"Kayrock.DeleteAcls.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.DeleteAcls.html#min_vsn/0"},{"type":"type","title":"Kayrock.DeleteAcls.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.DeleteAcls.html#t:request_t/0"},{"type":"type","title":"Kayrock.DeleteAcls.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.DeleteAcls.html#t:response_t/0"},{"type":"module","title":"Kayrock.DeleteAcls.V0.Request","doc":"Kayrock-generated request struct for Kafka `delete_acls` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  filters: {:array,\n   [\n     resource_type: :int8,\n     resource_name: :nullable_string,\n     principal: :nullable_string,\n     host: :nullable_string,\n     operation: :int8,\n     permission_type: :int8\n   ]}\n]\n```","ref":"Kayrock.DeleteAcls.V0.Request.html"},{"type":"function","title":"Kayrock.DeleteAcls.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DeleteAcls.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DeleteAcls.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DeleteAcls.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DeleteAcls.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DeleteAcls.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DeleteAcls.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DeleteAcls.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.DeleteAcls.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DeleteAcls.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DeleteAcls.V0.Request.t/0","doc":"Request struct for the Kafka `delete_acls` API v0","ref":"Kayrock.DeleteAcls.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DeleteAcls.V0.Response","doc":"Kayrock-generated response struct for Kafka `delete_acls` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  filter_responses: {:array,\n   [\n     error_code: :int16,\n     error_message: :nullable_string,\n     matching_acls: {:array,\n      [\n        error_code: :int16,\n        error_message: :nullable_string,\n        resource_type: :int8,\n        resource_name: :string,\n        principal: :string,\n        host: :string,\n        operation: :int8,\n        permission_type: :int8\n      ]}\n   ]}\n]\n```","ref":"Kayrock.DeleteAcls.V0.Response.html"},{"type":"function","title":"Kayrock.DeleteAcls.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DeleteAcls.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DeleteAcls.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DeleteAcls.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DeleteAcls.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DeleteAcls.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DeleteAcls.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DeleteAcls.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.DeleteAcls.V0.Response.t/0","doc":"Response struct for the Kafka `delete_acls` API v0","ref":"Kayrock.DeleteAcls.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DeleteGroups","doc":"Kayrock-generated module for the Kafka `delete_groups` API","ref":"Kayrock.DeleteGroups.html"},{"type":"function","title":"Kayrock.DeleteGroups.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.DeleteGroups.html#deserialize/2"},{"type":"function","title":"Kayrock.DeleteGroups.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.DeleteGroups.html#get_request_struct/1"},{"type":"function","title":"Kayrock.DeleteGroups.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.DeleteGroups.html#max_vsn/0"},{"type":"function","title":"Kayrock.DeleteGroups.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.DeleteGroups.html#min_vsn/0"},{"type":"type","title":"Kayrock.DeleteGroups.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.DeleteGroups.html#t:request_t/0"},{"type":"type","title":"Kayrock.DeleteGroups.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.DeleteGroups.html#t:response_t/0"},{"type":"module","title":"Kayrock.DeleteGroups.V0.Request","doc":"Kayrock-generated request struct for Kafka `delete_groups` v0 API\nmessages\n\nThe schema of this API is\n```\n[groups: {:array, :string}]\n```","ref":"Kayrock.DeleteGroups.V0.Request.html"},{"type":"function","title":"Kayrock.DeleteGroups.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DeleteGroups.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DeleteGroups.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DeleteGroups.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DeleteGroups.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DeleteGroups.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DeleteGroups.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DeleteGroups.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.DeleteGroups.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DeleteGroups.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DeleteGroups.V0.Request.t/0","doc":"Request struct for the Kafka `delete_groups` API v0","ref":"Kayrock.DeleteGroups.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DeleteGroups.V0.Response","doc":"Kayrock-generated response struct for Kafka `delete_groups` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  group_error_codes: {:array, [group_id: :string, error_code: :int16]}\n]\n```","ref":"Kayrock.DeleteGroups.V0.Response.html"},{"type":"function","title":"Kayrock.DeleteGroups.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DeleteGroups.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DeleteGroups.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DeleteGroups.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DeleteGroups.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DeleteGroups.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DeleteGroups.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DeleteGroups.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.DeleteGroups.V0.Response.t/0","doc":"Response struct for the Kafka `delete_groups` API v0","ref":"Kayrock.DeleteGroups.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DeleteRecords","doc":"Kayrock-generated module for the Kafka `delete_records` API","ref":"Kayrock.DeleteRecords.html"},{"type":"function","title":"Kayrock.DeleteRecords.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.DeleteRecords.html#deserialize/2"},{"type":"function","title":"Kayrock.DeleteRecords.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.DeleteRecords.html#get_request_struct/1"},{"type":"function","title":"Kayrock.DeleteRecords.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.DeleteRecords.html#max_vsn/0"},{"type":"function","title":"Kayrock.DeleteRecords.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.DeleteRecords.html#min_vsn/0"},{"type":"type","title":"Kayrock.DeleteRecords.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.DeleteRecords.html#t:request_t/0"},{"type":"type","title":"Kayrock.DeleteRecords.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.DeleteRecords.html#t:response_t/0"},{"type":"module","title":"Kayrock.DeleteRecords.V0.Request","doc":"Kayrock-generated request struct for Kafka `delete_records` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  topics: {:array,\n   [topic: :string, partitions: {:array, [partition: :int32, offset: :int64]}]},\n  timeout: :int32\n]\n```","ref":"Kayrock.DeleteRecords.V0.Request.html"},{"type":"function","title":"Kayrock.DeleteRecords.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DeleteRecords.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DeleteRecords.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DeleteRecords.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DeleteRecords.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DeleteRecords.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DeleteRecords.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DeleteRecords.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.DeleteRecords.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DeleteRecords.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DeleteRecords.V0.Request.t/0","doc":"Request struct for the Kafka `delete_records` API v0","ref":"Kayrock.DeleteRecords.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DeleteRecords.V0.Response","doc":"Kayrock-generated response struct for Kafka `delete_records` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, low_watermark: :int64, error_code: :int16]}\n   ]}\n]\n```","ref":"Kayrock.DeleteRecords.V0.Response.html"},{"type":"function","title":"Kayrock.DeleteRecords.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DeleteRecords.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DeleteRecords.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DeleteRecords.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DeleteRecords.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DeleteRecords.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DeleteRecords.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DeleteRecords.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.DeleteRecords.V0.Response.t/0","doc":"Response struct for the Kafka `delete_records` API v0","ref":"Kayrock.DeleteRecords.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DeleteTopics","doc":"Kayrock-generated module for the Kafka `delete_topics` API","ref":"Kayrock.DeleteTopics.html"},{"type":"function","title":"Kayrock.DeleteTopics.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.DeleteTopics.html#deserialize/2"},{"type":"function","title":"Kayrock.DeleteTopics.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.DeleteTopics.html#get_request_struct/1"},{"type":"function","title":"Kayrock.DeleteTopics.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (1)","ref":"Kayrock.DeleteTopics.html#max_vsn/0"},{"type":"function","title":"Kayrock.DeleteTopics.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.DeleteTopics.html#min_vsn/0"},{"type":"type","title":"Kayrock.DeleteTopics.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.DeleteTopics.html#t:request_t/0"},{"type":"type","title":"Kayrock.DeleteTopics.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.DeleteTopics.html#t:response_t/0"},{"type":"module","title":"Kayrock.DeleteTopics.V0.Request","doc":"Kayrock-generated request struct for Kafka `delete_topics` v0 API\nmessages\n\nThe schema of this API is\n```\n[topics: {:array, :string}, timeout: :int32]\n```","ref":"Kayrock.DeleteTopics.V0.Request.html"},{"type":"function","title":"Kayrock.DeleteTopics.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DeleteTopics.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DeleteTopics.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DeleteTopics.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DeleteTopics.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DeleteTopics.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DeleteTopics.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DeleteTopics.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.DeleteTopics.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DeleteTopics.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DeleteTopics.V0.Request.t/0","doc":"Request struct for the Kafka `delete_topics` API v0","ref":"Kayrock.DeleteTopics.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DeleteTopics.V0.Response","doc":"Kayrock-generated response struct for Kafka `delete_topics` v0 API\nmessages\n\nThe schema of this API is\n```\n[topic_error_codes: {:array, [topic: :string, error_code: :int16]}]\n```","ref":"Kayrock.DeleteTopics.V0.Response.html"},{"type":"function","title":"Kayrock.DeleteTopics.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DeleteTopics.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DeleteTopics.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DeleteTopics.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DeleteTopics.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DeleteTopics.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DeleteTopics.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DeleteTopics.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.DeleteTopics.V0.Response.t/0","doc":"Response struct for the Kafka `delete_topics` API v0","ref":"Kayrock.DeleteTopics.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DeleteTopics.V1.Request","doc":"Kayrock-generated request struct for Kafka `delete_topics` v1 API\nmessages\n\nThe schema of this API is\n```\n[topics: {:array, :string}, timeout: :int32]\n```","ref":"Kayrock.DeleteTopics.V1.Request.html"},{"type":"function","title":"Kayrock.DeleteTopics.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DeleteTopics.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DeleteTopics.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.DeleteTopics.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DeleteTopics.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DeleteTopics.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DeleteTopics.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DeleteTopics.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.DeleteTopics.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DeleteTopics.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DeleteTopics.V1.Request.t/0","doc":"Request struct for the Kafka `delete_topics` API v1","ref":"Kayrock.DeleteTopics.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DeleteTopics.V1.Response","doc":"Kayrock-generated response struct for Kafka `delete_topics` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  topic_error_codes: {:array, [topic: :string, error_code: :int16]}\n]\n```","ref":"Kayrock.DeleteTopics.V1.Response.html"},{"type":"function","title":"Kayrock.DeleteTopics.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DeleteTopics.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DeleteTopics.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.DeleteTopics.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DeleteTopics.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DeleteTopics.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DeleteTopics.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DeleteTopics.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.DeleteTopics.V1.Response.t/0","doc":"Response struct for the Kafka `delete_topics` API v1","ref":"Kayrock.DeleteTopics.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeAcls","doc":"Kayrock-generated module for the Kafka `describe_acls` API","ref":"Kayrock.DescribeAcls.html"},{"type":"function","title":"Kayrock.DescribeAcls.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.DescribeAcls.html#deserialize/2"},{"type":"function","title":"Kayrock.DescribeAcls.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.DescribeAcls.html#get_request_struct/1"},{"type":"function","title":"Kayrock.DescribeAcls.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.DescribeAcls.html#max_vsn/0"},{"type":"function","title":"Kayrock.DescribeAcls.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.DescribeAcls.html#min_vsn/0"},{"type":"type","title":"Kayrock.DescribeAcls.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.DescribeAcls.html#t:request_t/0"},{"type":"type","title":"Kayrock.DescribeAcls.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.DescribeAcls.html#t:response_t/0"},{"type":"module","title":"Kayrock.DescribeAcls.V0.Request","doc":"Kayrock-generated request struct for Kafka `describe_acls` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  resource_type: :int8,\n  resource_name: :nullable_string,\n  principal: :nullable_string,\n  host: :nullable_string,\n  operation: :int8,\n  permission_type: :int8\n]\n```","ref":"Kayrock.DescribeAcls.V0.Request.html"},{"type":"function","title":"Kayrock.DescribeAcls.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeAcls.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeAcls.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DescribeAcls.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeAcls.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DescribeAcls.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DescribeAcls.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeAcls.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.DescribeAcls.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DescribeAcls.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DescribeAcls.V0.Request.t/0","doc":"Request struct for the Kafka `describe_acls` API v0","ref":"Kayrock.DescribeAcls.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeAcls.V0.Response","doc":"Kayrock-generated response struct for Kafka `describe_acls` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  error_code: :int16,\n  error_message: :nullable_string,\n  resources: {:array,\n   [\n     resource_type: :int8,\n     resource_name: :string,\n     acls: {:array,\n      [\n        principal: :string,\n        host: :string,\n        operation: :int8,\n        permission_type: :int8\n      ]}\n   ]}\n]\n```","ref":"Kayrock.DescribeAcls.V0.Response.html"},{"type":"function","title":"Kayrock.DescribeAcls.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeAcls.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeAcls.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DescribeAcls.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeAcls.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DescribeAcls.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DescribeAcls.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeAcls.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.DescribeAcls.V0.Response.t/0","doc":"Response struct for the Kafka `describe_acls` API v0","ref":"Kayrock.DescribeAcls.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeConfigs","doc":"Kayrock-generated module for the Kafka `describe_configs` API","ref":"Kayrock.DescribeConfigs.html"},{"type":"function","title":"Kayrock.DescribeConfigs.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.DescribeConfigs.html#deserialize/2"},{"type":"function","title":"Kayrock.DescribeConfigs.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.DescribeConfigs.html#get_request_struct/1"},{"type":"function","title":"Kayrock.DescribeConfigs.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (1)","ref":"Kayrock.DescribeConfigs.html#max_vsn/0"},{"type":"function","title":"Kayrock.DescribeConfigs.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.DescribeConfigs.html#min_vsn/0"},{"type":"type","title":"Kayrock.DescribeConfigs.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.DescribeConfigs.html#t:request_t/0"},{"type":"type","title":"Kayrock.DescribeConfigs.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.DescribeConfigs.html#t:response_t/0"},{"type":"module","title":"Kayrock.DescribeConfigs.V0.Request","doc":"Kayrock-generated request struct for Kafka `describe_configs` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  resources: {:array,\n   [\n     resource_type: :int8,\n     resource_name: :string,\n     config_names: {:array, :string}\n   ]}\n]\n```","ref":"Kayrock.DescribeConfigs.V0.Request.html"},{"type":"function","title":"Kayrock.DescribeConfigs.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeConfigs.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DescribeConfigs.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DescribeConfigs.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeConfigs.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DescribeConfigs.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DescribeConfigs.V0.Request.t/0","doc":"Request struct for the Kafka `describe_configs` API v0","ref":"Kayrock.DescribeConfigs.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeConfigs.V0.Response","doc":"Kayrock-generated response struct for Kafka `describe_configs` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  resources: {:array,\n   [\n     error_code: :int16,\n     error_message: :nullable_string,\n     resource_type: :int8,\n     resource_name: :string,\n     config_entries: {:array,\n      [\n        config_name: :string,\n        config_value: :nullable_string,\n        read_only: :boolean,\n        is_default: :boolean,\n        is_sensitive: :boolean\n      ]}\n   ]}\n]\n```","ref":"Kayrock.DescribeConfigs.V0.Response.html"},{"type":"function","title":"Kayrock.DescribeConfigs.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeConfigs.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DescribeConfigs.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DescribeConfigs.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DescribeConfigs.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeConfigs.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.DescribeConfigs.V0.Response.t/0","doc":"Response struct for the Kafka `describe_configs` API v0","ref":"Kayrock.DescribeConfigs.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeConfigs.V1.Request","doc":"Kayrock-generated request struct for Kafka `describe_configs` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  resources: {:array,\n   [\n     resource_type: :int8,\n     resource_name: :string,\n     config_names: {:array, :string}\n   ]},\n  include_synonyms: :boolean\n]\n```","ref":"Kayrock.DescribeConfigs.V1.Request.html"},{"type":"function","title":"Kayrock.DescribeConfigs.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeConfigs.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.DescribeConfigs.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DescribeConfigs.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeConfigs.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DescribeConfigs.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DescribeConfigs.V1.Request.t/0","doc":"Request struct for the Kafka `describe_configs` API v1","ref":"Kayrock.DescribeConfigs.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeConfigs.V1.Response","doc":"Kayrock-generated response struct for Kafka `describe_configs` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  resources: {:array,\n   [\n     error_code: :int16,\n     error_message: :nullable_string,\n     resource_type: :int8,\n     resource_name: :string,\n     config_entries: {:array,\n      [\n        config_name: :string,\n        config_value: :nullable_string,\n        read_only: :boolean,\n        config_source: :int8,\n        is_sensitive: :boolean,\n        config_synonyms: {:array,\n         [\n           config_name: :string,\n           config_value: :nullable_string,\n           config_source: :int8\n         ]}\n      ]}\n   ]}\n]\n```","ref":"Kayrock.DescribeConfigs.V1.Response.html"},{"type":"function","title":"Kayrock.DescribeConfigs.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeConfigs.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.DescribeConfigs.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeConfigs.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DescribeConfigs.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DescribeConfigs.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeConfigs.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.DescribeConfigs.V1.Response.t/0","doc":"Response struct for the Kafka `describe_configs` API v1","ref":"Kayrock.DescribeConfigs.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeDelegationToken","doc":"Kayrock-generated module for the Kafka `describe_delegation_token` API","ref":"Kayrock.DescribeDelegationToken.html"},{"type":"function","title":"Kayrock.DescribeDelegationToken.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.DescribeDelegationToken.html#deserialize/2"},{"type":"function","title":"Kayrock.DescribeDelegationToken.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.DescribeDelegationToken.html#get_request_struct/1"},{"type":"function","title":"Kayrock.DescribeDelegationToken.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.DescribeDelegationToken.html#max_vsn/0"},{"type":"function","title":"Kayrock.DescribeDelegationToken.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.DescribeDelegationToken.html#min_vsn/0"},{"type":"type","title":"Kayrock.DescribeDelegationToken.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.DescribeDelegationToken.html#t:request_t/0"},{"type":"type","title":"Kayrock.DescribeDelegationToken.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.DescribeDelegationToken.html#t:response_t/0"},{"type":"module","title":"Kayrock.DescribeDelegationToken.V0.Request","doc":"Kayrock-generated request struct for Kafka `describe_delegation_token` v0 API\nmessages\n\nThe schema of this API is\n```\n[owners: {:array, [principal_type: :string, name: :string]}]\n```","ref":"Kayrock.DescribeDelegationToken.V0.Request.html"},{"type":"function","title":"Kayrock.DescribeDelegationToken.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeDelegationToken.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeDelegationToken.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DescribeDelegationToken.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeDelegationToken.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DescribeDelegationToken.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DescribeDelegationToken.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeDelegationToken.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.DescribeDelegationToken.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DescribeDelegationToken.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DescribeDelegationToken.V0.Request.t/0","doc":"Request struct for the Kafka `describe_delegation_token` API v0","ref":"Kayrock.DescribeDelegationToken.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeDelegationToken.V0.Response","doc":"Kayrock-generated response struct for Kafka `describe_delegation_token` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  error_code: :int16,\n  token_details: {:array,\n   [\n     owner: [principal_type: :string, name: :string],\n     issue_timestamp: :int64,\n     expiry_timestamp: :int64,\n     max_timestamp: :int64,\n     token_id: :string,\n     hmac: :bytes,\n     renewers: {:array, [principal_type: :string, name: :string]}\n   ]},\n  throttle_time_ms: :int32\n]\n```","ref":"Kayrock.DescribeDelegationToken.V0.Response.html"},{"type":"function","title":"Kayrock.DescribeDelegationToken.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeDelegationToken.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeDelegationToken.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DescribeDelegationToken.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeDelegationToken.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DescribeDelegationToken.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DescribeDelegationToken.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeDelegationToken.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.DescribeDelegationToken.V0.Response.t/0","doc":"Response struct for the Kafka `describe_delegation_token` API v0","ref":"Kayrock.DescribeDelegationToken.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeGroups","doc":"Kayrock-generated module for the Kafka `describe_groups` API","ref":"Kayrock.DescribeGroups.html"},{"type":"function","title":"Kayrock.DescribeGroups.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.DescribeGroups.html#deserialize/2"},{"type":"function","title":"Kayrock.DescribeGroups.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.DescribeGroups.html#get_request_struct/1"},{"type":"function","title":"Kayrock.DescribeGroups.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (1)","ref":"Kayrock.DescribeGroups.html#max_vsn/0"},{"type":"function","title":"Kayrock.DescribeGroups.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.DescribeGroups.html#min_vsn/0"},{"type":"type","title":"Kayrock.DescribeGroups.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.DescribeGroups.html#t:request_t/0"},{"type":"type","title":"Kayrock.DescribeGroups.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.DescribeGroups.html#t:response_t/0"},{"type":"module","title":"Kayrock.DescribeGroups.V0.Request","doc":"Kayrock-generated request struct for Kafka `describe_groups` v0 API\nmessages\n\nThe schema of this API is\n```\n[group_ids: {:array, :string}]\n```","ref":"Kayrock.DescribeGroups.V0.Request.html"},{"type":"function","title":"Kayrock.DescribeGroups.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeGroups.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeGroups.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DescribeGroups.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeGroups.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DescribeGroups.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DescribeGroups.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeGroups.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.DescribeGroups.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DescribeGroups.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DescribeGroups.V0.Request.t/0","doc":"Request struct for the Kafka `describe_groups` API v0","ref":"Kayrock.DescribeGroups.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeGroups.V0.Response","doc":"Kayrock-generated response struct for Kafka `describe_groups` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  groups: {:array,\n   [\n     error_code: :int16,\n     group_id: :string,\n     state: :string,\n     protocol_type: :string,\n     protocol: :string,\n     members: {:array,\n      [\n        member_id: :string,\n        client_id: :string,\n        client_host: :string,\n        member_metadata: :bytes,\n        member_assignment: :bytes\n      ]}\n   ]}\n]\n```","ref":"Kayrock.DescribeGroups.V0.Response.html"},{"type":"function","title":"Kayrock.DescribeGroups.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeGroups.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeGroups.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DescribeGroups.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeGroups.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DescribeGroups.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DescribeGroups.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeGroups.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.DescribeGroups.V0.Response.t/0","doc":"Response struct for the Kafka `describe_groups` API v0","ref":"Kayrock.DescribeGroups.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeGroups.V1.Request","doc":"Kayrock-generated request struct for Kafka `describe_groups` v1 API\nmessages\n\nThe schema of this API is\n```\n[group_ids: {:array, :string}]\n```","ref":"Kayrock.DescribeGroups.V1.Request.html"},{"type":"function","title":"Kayrock.DescribeGroups.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeGroups.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeGroups.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.DescribeGroups.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeGroups.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DescribeGroups.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DescribeGroups.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeGroups.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.DescribeGroups.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DescribeGroups.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DescribeGroups.V1.Request.t/0","doc":"Request struct for the Kafka `describe_groups` API v1","ref":"Kayrock.DescribeGroups.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeGroups.V1.Response","doc":"Kayrock-generated response struct for Kafka `describe_groups` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  groups: {:array,\n   [\n     error_code: :int16,\n     group_id: :string,\n     state: :string,\n     protocol_type: :string,\n     protocol: :string,\n     members: {:array,\n      [\n        member_id: :string,\n        client_id: :string,\n        client_host: :string,\n        member_metadata: :bytes,\n        member_assignment: :bytes\n      ]}\n   ]}\n]\n```","ref":"Kayrock.DescribeGroups.V1.Response.html"},{"type":"function","title":"Kayrock.DescribeGroups.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeGroups.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeGroups.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.DescribeGroups.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeGroups.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DescribeGroups.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DescribeGroups.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeGroups.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.DescribeGroups.V1.Response.t/0","doc":"Response struct for the Kafka `describe_groups` API v1","ref":"Kayrock.DescribeGroups.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeLogDirs","doc":"Kayrock-generated module for the Kafka `describe_log_dirs` API","ref":"Kayrock.DescribeLogDirs.html"},{"type":"function","title":"Kayrock.DescribeLogDirs.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.DescribeLogDirs.html#deserialize/2"},{"type":"function","title":"Kayrock.DescribeLogDirs.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.DescribeLogDirs.html#get_request_struct/1"},{"type":"function","title":"Kayrock.DescribeLogDirs.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.DescribeLogDirs.html#max_vsn/0"},{"type":"function","title":"Kayrock.DescribeLogDirs.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.DescribeLogDirs.html#min_vsn/0"},{"type":"type","title":"Kayrock.DescribeLogDirs.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.DescribeLogDirs.html#t:request_t/0"},{"type":"type","title":"Kayrock.DescribeLogDirs.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.DescribeLogDirs.html#t:response_t/0"},{"type":"module","title":"Kayrock.DescribeLogDirs.V0.Request","doc":"Kayrock-generated request struct for Kafka `describe_log_dirs` v0 API\nmessages\n\nThe schema of this API is\n```\n[topics: {:array, [topic: :string, partitions: {:array, :int32}]}]\n```","ref":"Kayrock.DescribeLogDirs.V0.Request.html"},{"type":"function","title":"Kayrock.DescribeLogDirs.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeLogDirs.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeLogDirs.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DescribeLogDirs.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeLogDirs.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.DescribeLogDirs.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.DescribeLogDirs.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeLogDirs.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.DescribeLogDirs.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.DescribeLogDirs.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.DescribeLogDirs.V0.Request.t/0","doc":"Request struct for the Kafka `describe_log_dirs` API v0","ref":"Kayrock.DescribeLogDirs.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.DescribeLogDirs.V0.Response","doc":"Kayrock-generated response struct for Kafka `describe_log_dirs` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  log_dirs: {:array,\n   [\n     error_code: :int16,\n     log_dir: :string,\n     topics: {:array,\n      [\n        topic: :string,\n        partitions: {:array,\n         [\n           partition: :int32,\n           size: :int64,\n           offset_lag: :int64,\n           is_future: :boolean\n         ]}\n      ]}\n   ]}\n]\n```","ref":"Kayrock.DescribeLogDirs.V0.Response.html"},{"type":"function","title":"Kayrock.DescribeLogDirs.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.DescribeLogDirs.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.DescribeLogDirs.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.DescribeLogDirs.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.DescribeLogDirs.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.DescribeLogDirs.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.DescribeLogDirs.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.DescribeLogDirs.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.DescribeLogDirs.V0.Response.t/0","doc":"Response struct for the Kafka `describe_log_dirs` API v0","ref":"Kayrock.DescribeLogDirs.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Deserialize","doc":"Deserialization for primitive types for the kafka protocol","ref":"Kayrock.Deserialize.html"},{"type":"function","title":"Kayrock.Deserialize.deserialize/2","doc":"","ref":"Kayrock.Deserialize.html#deserialize/2"},{"type":"function","title":"Kayrock.Deserialize.deserialize_array/2","doc":"","ref":"Kayrock.Deserialize.html#deserialize_array/2"},{"type":"macro","title":"Kayrock.Deserialize.primitive_types/0","doc":"","ref":"Kayrock.Deserialize.html#primitive_types/0"},{"type":"module","title":"Kayrock.EndTxn","doc":"Kayrock-generated module for the Kafka `end_txn` API","ref":"Kayrock.EndTxn.html"},{"type":"function","title":"Kayrock.EndTxn.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.EndTxn.html#deserialize/2"},{"type":"function","title":"Kayrock.EndTxn.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.EndTxn.html#get_request_struct/1"},{"type":"function","title":"Kayrock.EndTxn.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.EndTxn.html#max_vsn/0"},{"type":"function","title":"Kayrock.EndTxn.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.EndTxn.html#min_vsn/0"},{"type":"type","title":"Kayrock.EndTxn.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.EndTxn.html#t:request_t/0"},{"type":"type","title":"Kayrock.EndTxn.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.EndTxn.html#t:response_t/0"},{"type":"module","title":"Kayrock.EndTxn.V0.Request","doc":"Kayrock-generated request struct for Kafka `end_txn` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  transactional_id: :string,\n  producer_id: :int64,\n  producer_epoch: :int16,\n  transaction_result: :boolean\n]\n```","ref":"Kayrock.EndTxn.V0.Request.html"},{"type":"function","title":"Kayrock.EndTxn.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.EndTxn.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.EndTxn.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.EndTxn.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.EndTxn.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.EndTxn.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.EndTxn.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.EndTxn.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.EndTxn.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.EndTxn.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.EndTxn.V0.Request.t/0","doc":"Request struct for the Kafka `end_txn` API v0","ref":"Kayrock.EndTxn.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.EndTxn.V0.Response","doc":"Kayrock-generated response struct for Kafka `end_txn` v0 API\nmessages\n\nThe schema of this API is\n```\n[throttle_time_ms: :int32, error_code: :int16]\n```","ref":"Kayrock.EndTxn.V0.Response.html"},{"type":"function","title":"Kayrock.EndTxn.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.EndTxn.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.EndTxn.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.EndTxn.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.EndTxn.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.EndTxn.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.EndTxn.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.EndTxn.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.EndTxn.V0.Response.t/0","doc":"Response struct for the Kafka `end_txn` API v0","ref":"Kayrock.EndTxn.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.ErrorCode","doc":"Utility for converting Kafka error codes to/from atom names\n\nNote the actual error code values are determined by `:kpro_schema.c/1`.\nCurrently covering the range -1 to 71.\n\nSee https://kafka.apache.org/protocol#protocol_error_codes","ref":"Kayrock.ErrorCode.html"},{"type":"function","title":"Kayrock.ErrorCode.atom_to_code/1","doc":"Converts an atom to a numeric error code\n\nReturns nil if an unknown atom is supplied","ref":"Kayrock.ErrorCode.html#atom_to_code/1"},{"type":"function","title":"Kayrock.ErrorCode.atom_to_code!/1","doc":"Converts an atom to a numeric error code, raising an\n`Kayrock.ErrorCode.InvalidAtomException` if an unknown atom is supplied","ref":"Kayrock.ErrorCode.html#atom_to_code!/1"},{"type":"function","title":"Kayrock.ErrorCode.code_to_atom/1","doc":"Converts an error code to an atom\n\nAn unknown code results in a return of `:unknown`","ref":"Kayrock.ErrorCode.html#code_to_atom/1"},{"type":"function","title":"Kayrock.ErrorCode.code_to_atom!/1","doc":"Converts an error code to an atom, raising an\n`Kayrock.ErrorCode.InvalidErrorCodeException` if an unknown error code is supplied","ref":"Kayrock.ErrorCode.html#code_to_atom!/1"},{"type":"function","title":"Kayrock.ErrorCode.unknown_topic/0","doc":"","ref":"Kayrock.ErrorCode.html#unknown_topic/0"},{"type":"type","title":"Kayrock.ErrorCode.error_atom/0","doc":"An erlang/elixir atom representation of an error code","ref":"Kayrock.ErrorCode.html#t:error_atom/0"},{"type":"type","title":"Kayrock.ErrorCode.error_code/0","doc":"A numeric Kafka error code","ref":"Kayrock.ErrorCode.html#t:error_code/0"},{"type":"module","title":"Kayrock.ExpireDelegationToken","doc":"Kayrock-generated module for the Kafka `expire_delegation_token` API","ref":"Kayrock.ExpireDelegationToken.html"},{"type":"function","title":"Kayrock.ExpireDelegationToken.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.ExpireDelegationToken.html#deserialize/2"},{"type":"function","title":"Kayrock.ExpireDelegationToken.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.ExpireDelegationToken.html#get_request_struct/1"},{"type":"function","title":"Kayrock.ExpireDelegationToken.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.ExpireDelegationToken.html#max_vsn/0"},{"type":"function","title":"Kayrock.ExpireDelegationToken.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.ExpireDelegationToken.html#min_vsn/0"},{"type":"type","title":"Kayrock.ExpireDelegationToken.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.ExpireDelegationToken.html#t:request_t/0"},{"type":"type","title":"Kayrock.ExpireDelegationToken.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.ExpireDelegationToken.html#t:response_t/0"},{"type":"module","title":"Kayrock.ExpireDelegationToken.V0.Request","doc":"Kayrock-generated request struct for Kafka `expire_delegation_token` v0 API\nmessages\n\nThe schema of this API is\n```\n[hmac: :bytes, expiry_time_period: :int64]\n```","ref":"Kayrock.ExpireDelegationToken.V0.Request.html"},{"type":"function","title":"Kayrock.ExpireDelegationToken.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ExpireDelegationToken.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.ExpireDelegationToken.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.ExpireDelegationToken.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.ExpireDelegationToken.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.ExpireDelegationToken.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.ExpireDelegationToken.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ExpireDelegationToken.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.ExpireDelegationToken.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.ExpireDelegationToken.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.ExpireDelegationToken.V0.Request.t/0","doc":"Request struct for the Kafka `expire_delegation_token` API v0","ref":"Kayrock.ExpireDelegationToken.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.ExpireDelegationToken.V0.Response","doc":"Kayrock-generated response struct for Kafka `expire_delegation_token` v0 API\nmessages\n\nThe schema of this API is\n```\n[error_code: :int16, expiry_timestamp: :int64, throttle_time_ms: :int32]\n```","ref":"Kayrock.ExpireDelegationToken.V0.Response.html"},{"type":"function","title":"Kayrock.ExpireDelegationToken.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ExpireDelegationToken.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.ExpireDelegationToken.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.ExpireDelegationToken.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.ExpireDelegationToken.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.ExpireDelegationToken.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.ExpireDelegationToken.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ExpireDelegationToken.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.ExpireDelegationToken.V0.Response.t/0","doc":"Response struct for the Kafka `expire_delegation_token` API v0","ref":"Kayrock.ExpireDelegationToken.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch","doc":"Kayrock-generated module for the Kafka `fetch` API","ref":"Kayrock.Fetch.html"},{"type":"function","title":"Kayrock.Fetch.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.Fetch.html#deserialize/2"},{"type":"function","title":"Kayrock.Fetch.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.Fetch.html#get_request_struct/1"},{"type":"function","title":"Kayrock.Fetch.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (7)","ref":"Kayrock.Fetch.html#max_vsn/0"},{"type":"function","title":"Kayrock.Fetch.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.Fetch.html#min_vsn/0"},{"type":"type","title":"Kayrock.Fetch.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.Fetch.html#t:request_t/0"},{"type":"type","title":"Kayrock.Fetch.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.Fetch.html#t:response_t/0"},{"type":"module","title":"Kayrock.Fetch.V0.Request","doc":"Kayrock-generated request struct for Kafka `fetch` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  max_wait_time: :int32,\n  min_bytes: :int32,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, fetch_offset: :int64, max_bytes: :int32]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V0.Request.html"},{"type":"function","title":"Kayrock.Fetch.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.Fetch.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Fetch.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Fetch.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.Fetch.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Fetch.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Fetch.V0.Request.t/0","doc":"Request struct for the Kafka `fetch` API v0","ref":"Kayrock.Fetch.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V0.Response","doc":"Kayrock-generated response struct for Kafka `fetch` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition_header: [\n          partition: :int32,\n          error_code: :int16,\n          high_watermark: :int64\n        ],\n        record_set: :records\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V0.Response.html"},{"type":"function","title":"Kayrock.Fetch.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.Fetch.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Fetch.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Fetch.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.Fetch.V0.Response.t/0","doc":"Response struct for the Kafka `fetch` API v0","ref":"Kayrock.Fetch.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V1.Request","doc":"Kayrock-generated request struct for Kafka `fetch` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  max_wait_time: :int32,\n  min_bytes: :int32,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, fetch_offset: :int64, max_bytes: :int32]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V1.Request.html"},{"type":"function","title":"Kayrock.Fetch.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.Fetch.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Fetch.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Fetch.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.Fetch.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Fetch.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Fetch.V1.Request.t/0","doc":"Request struct for the Kafka `fetch` API v1","ref":"Kayrock.Fetch.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V1.Response","doc":"Kayrock-generated response struct for Kafka `fetch` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition_header: [\n          partition: :int32,\n          error_code: :int16,\n          high_watermark: :int64\n        ],\n        record_set: :records\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V1.Response.html"},{"type":"function","title":"Kayrock.Fetch.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.Fetch.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Fetch.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Fetch.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.Fetch.V1.Response.t/0","doc":"Response struct for the Kafka `fetch` API v1","ref":"Kayrock.Fetch.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V2.Request","doc":"Kayrock-generated request struct for Kafka `fetch` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  max_wait_time: :int32,\n  min_bytes: :int32,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, fetch_offset: :int64, max_bytes: :int32]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V2.Request.html"},{"type":"function","title":"Kayrock.Fetch.V2.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V2.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V2.Request.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.Fetch.V2.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V2.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Fetch.V2.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Fetch.V2.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V2.Request.html#schema/0"},{"type":"function","title":"Kayrock.Fetch.V2.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Fetch.V2.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Fetch.V2.Request.t/0","doc":"Request struct for the Kafka `fetch` API v2","ref":"Kayrock.Fetch.V2.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V2.Response","doc":"Kayrock-generated response struct for Kafka `fetch` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition_header: [\n          partition: :int32,\n          error_code: :int16,\n          high_watermark: :int64\n        ],\n        record_set: :records\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V2.Response.html"},{"type":"function","title":"Kayrock.Fetch.V2.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V2.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V2.Response.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.Fetch.V2.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V2.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Fetch.V2.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Fetch.V2.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V2.Response.html#schema/0"},{"type":"type","title":"Kayrock.Fetch.V2.Response.t/0","doc":"Response struct for the Kafka `fetch` API v2","ref":"Kayrock.Fetch.V2.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V3.Request","doc":"Kayrock-generated request struct for Kafka `fetch` v3 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  max_wait_time: :int32,\n  min_bytes: :int32,\n  max_bytes: :int32,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, fetch_offset: :int64, max_bytes: :int32]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V3.Request.html"},{"type":"function","title":"Kayrock.Fetch.V3.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V3.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V3.Request.api_vsn/0","doc":"Returns the API version (3) implemented by this module","ref":"Kayrock.Fetch.V3.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V3.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Fetch.V3.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Fetch.V3.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V3.Request.html#schema/0"},{"type":"function","title":"Kayrock.Fetch.V3.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Fetch.V3.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Fetch.V3.Request.t/0","doc":"Request struct for the Kafka `fetch` API v3","ref":"Kayrock.Fetch.V3.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V3.Response","doc":"Kayrock-generated response struct for Kafka `fetch` v3 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition_header: [\n          partition: :int32,\n          error_code: :int16,\n          high_watermark: :int64\n        ],\n        record_set: :records\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V3.Response.html"},{"type":"function","title":"Kayrock.Fetch.V3.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V3.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V3.Response.api_vsn/0","doc":"Returns the API version (3) implemented by this module","ref":"Kayrock.Fetch.V3.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V3.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Fetch.V3.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Fetch.V3.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V3.Response.html#schema/0"},{"type":"type","title":"Kayrock.Fetch.V3.Response.t/0","doc":"Response struct for the Kafka `fetch` API v3","ref":"Kayrock.Fetch.V3.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V4.Request","doc":"Kayrock-generated request struct for Kafka `fetch` v4 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  max_wait_time: :int32,\n  min_bytes: :int32,\n  max_bytes: :int32,\n  isolation_level: :int8,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, fetch_offset: :int64, max_bytes: :int32]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V4.Request.html"},{"type":"function","title":"Kayrock.Fetch.V4.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V4.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V4.Request.api_vsn/0","doc":"Returns the API version (4) implemented by this module","ref":"Kayrock.Fetch.V4.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V4.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Fetch.V4.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Fetch.V4.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V4.Request.html#schema/0"},{"type":"function","title":"Kayrock.Fetch.V4.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Fetch.V4.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Fetch.V4.Request.t/0","doc":"Request struct for the Kafka `fetch` API v4","ref":"Kayrock.Fetch.V4.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V4.Response","doc":"Kayrock-generated response struct for Kafka `fetch` v4 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition_header: [\n          partition: :int32,\n          error_code: :int16,\n          high_watermark: :int64,\n          last_stable_offset: :int64,\n          aborted_transactions: {:array,\n           [producer_id: :int64, first_offset: :int64]}\n        ],\n        record_set: :records\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V4.Response.html"},{"type":"function","title":"Kayrock.Fetch.V4.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V4.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V4.Response.api_vsn/0","doc":"Returns the API version (4) implemented by this module","ref":"Kayrock.Fetch.V4.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V4.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Fetch.V4.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Fetch.V4.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V4.Response.html#schema/0"},{"type":"type","title":"Kayrock.Fetch.V4.Response.t/0","doc":"Response struct for the Kafka `fetch` API v4","ref":"Kayrock.Fetch.V4.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V5.Request","doc":"Kayrock-generated request struct for Kafka `fetch` v5 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  max_wait_time: :int32,\n  min_bytes: :int32,\n  max_bytes: :int32,\n  isolation_level: :int8,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [\n        partition: :int32,\n        fetch_offset: :int64,\n        log_start_offset: :int64,\n        max_bytes: :int32\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V5.Request.html"},{"type":"function","title":"Kayrock.Fetch.V5.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V5.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V5.Request.api_vsn/0","doc":"Returns the API version (5) implemented by this module","ref":"Kayrock.Fetch.V5.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V5.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Fetch.V5.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Fetch.V5.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V5.Request.html#schema/0"},{"type":"function","title":"Kayrock.Fetch.V5.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Fetch.V5.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Fetch.V5.Request.t/0","doc":"Request struct for the Kafka `fetch` API v5","ref":"Kayrock.Fetch.V5.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V5.Response","doc":"Kayrock-generated response struct for Kafka `fetch` v5 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition_header: [\n          partition: :int32,\n          error_code: :int16,\n          high_watermark: :int64,\n          last_stable_offset: :int64,\n          log_start_offset: :int64,\n          aborted_transactions: {:array,\n           [producer_id: :int64, first_offset: :int64]}\n        ],\n        record_set: :records\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V5.Response.html"},{"type":"function","title":"Kayrock.Fetch.V5.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V5.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V5.Response.api_vsn/0","doc":"Returns the API version (5) implemented by this module","ref":"Kayrock.Fetch.V5.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V5.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Fetch.V5.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Fetch.V5.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V5.Response.html#schema/0"},{"type":"type","title":"Kayrock.Fetch.V5.Response.t/0","doc":"Response struct for the Kafka `fetch` API v5","ref":"Kayrock.Fetch.V5.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V6.Request","doc":"Kayrock-generated request struct for Kafka `fetch` v6 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  max_wait_time: :int32,\n  min_bytes: :int32,\n  max_bytes: :int32,\n  isolation_level: :int8,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [\n        partition: :int32,\n        fetch_offset: :int64,\n        log_start_offset: :int64,\n        max_bytes: :int32\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V6.Request.html"},{"type":"function","title":"Kayrock.Fetch.V6.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V6.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V6.Request.api_vsn/0","doc":"Returns the API version (6) implemented by this module","ref":"Kayrock.Fetch.V6.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V6.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Fetch.V6.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Fetch.V6.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V6.Request.html#schema/0"},{"type":"function","title":"Kayrock.Fetch.V6.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Fetch.V6.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Fetch.V6.Request.t/0","doc":"Request struct for the Kafka `fetch` API v6","ref":"Kayrock.Fetch.V6.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V6.Response","doc":"Kayrock-generated response struct for Kafka `fetch` v6 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition_header: [\n          partition: :int32,\n          error_code: :int16,\n          high_watermark: :int64,\n          last_stable_offset: :int64,\n          log_start_offset: :int64,\n          aborted_transactions: {:array,\n           [producer_id: :int64, first_offset: :int64]}\n        ],\n        record_set: :records\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V6.Response.html"},{"type":"function","title":"Kayrock.Fetch.V6.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V6.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V6.Response.api_vsn/0","doc":"Returns the API version (6) implemented by this module","ref":"Kayrock.Fetch.V6.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V6.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Fetch.V6.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Fetch.V6.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V6.Response.html#schema/0"},{"type":"type","title":"Kayrock.Fetch.V6.Response.t/0","doc":"Response struct for the Kafka `fetch` API v6","ref":"Kayrock.Fetch.V6.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V7.Request","doc":"Kayrock-generated request struct for Kafka `fetch` v7 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  max_wait_time: :int32,\n  min_bytes: :int32,\n  max_bytes: :int32,\n  isolation_level: :int8,\n  session_id: :int32,\n  epoch: :int32,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [\n        partition: :int32,\n        fetch_offset: :int64,\n        log_start_offset: :int64,\n        max_bytes: :int32\n      ]}\n   ]},\n  forgetten_topics_data: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [\n        partition: :int32,\n        fetch_offset: :int64,\n        log_start_offset: :int64,\n        max_bytes: :int32\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V7.Request.html"},{"type":"function","title":"Kayrock.Fetch.V7.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V7.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V7.Request.api_vsn/0","doc":"Returns the API version (7) implemented by this module","ref":"Kayrock.Fetch.V7.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V7.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Fetch.V7.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Fetch.V7.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V7.Request.html#schema/0"},{"type":"function","title":"Kayrock.Fetch.V7.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Fetch.V7.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Fetch.V7.Request.t/0","doc":"Request struct for the Kafka `fetch` API v7","ref":"Kayrock.Fetch.V7.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Fetch.V7.Response","doc":"Kayrock-generated response struct for Kafka `fetch` v7 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  error_code: :int16,\n  session_id: :int32,\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition_header: [\n          partition: :int32,\n          error_code: :int16,\n          high_watermark: :int64,\n          last_stable_offset: :int64,\n          log_start_offset: :int64,\n          aborted_transactions: {:array,\n           [producer_id: :int64, first_offset: :int64]}\n        ],\n        record_set: :records\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Fetch.V7.Response.html"},{"type":"function","title":"Kayrock.Fetch.V7.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Fetch.V7.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Fetch.V7.Response.api_vsn/0","doc":"Returns the API version (7) implemented by this module","ref":"Kayrock.Fetch.V7.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Fetch.V7.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Fetch.V7.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Fetch.V7.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Fetch.V7.Response.html#schema/0"},{"type":"type","title":"Kayrock.Fetch.V7.Response.t/0","doc":"Response struct for the Kafka `fetch` API v7","ref":"Kayrock.Fetch.V7.Response.html#t:t/0"},{"type":"module","title":"Kayrock.FindCoordinator","doc":"Kayrock-generated module for the Kafka `find_coordinator` API","ref":"Kayrock.FindCoordinator.html"},{"type":"function","title":"Kayrock.FindCoordinator.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.FindCoordinator.html#deserialize/2"},{"type":"function","title":"Kayrock.FindCoordinator.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.FindCoordinator.html#get_request_struct/1"},{"type":"function","title":"Kayrock.FindCoordinator.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (1)","ref":"Kayrock.FindCoordinator.html#max_vsn/0"},{"type":"function","title":"Kayrock.FindCoordinator.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.FindCoordinator.html#min_vsn/0"},{"type":"type","title":"Kayrock.FindCoordinator.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.FindCoordinator.html#t:request_t/0"},{"type":"type","title":"Kayrock.FindCoordinator.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.FindCoordinator.html#t:response_t/0"},{"type":"module","title":"Kayrock.FindCoordinator.V0.Request","doc":"Kayrock-generated request struct for Kafka `find_coordinator` v0 API\nmessages\n\nThe schema of this API is\n```\n[group_id: :string]\n```","ref":"Kayrock.FindCoordinator.V0.Request.html"},{"type":"function","title":"Kayrock.FindCoordinator.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.FindCoordinator.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.FindCoordinator.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.FindCoordinator.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.FindCoordinator.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.FindCoordinator.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.FindCoordinator.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.FindCoordinator.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.FindCoordinator.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.FindCoordinator.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.FindCoordinator.V0.Request.t/0","doc":"Request struct for the Kafka `find_coordinator` API v0","ref":"Kayrock.FindCoordinator.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.FindCoordinator.V0.Response","doc":"Kayrock-generated response struct for Kafka `find_coordinator` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  error_code: :int16,\n  coordinator: [node_id: :int32, host: :string, port: :int32]\n]\n```","ref":"Kayrock.FindCoordinator.V0.Response.html"},{"type":"function","title":"Kayrock.FindCoordinator.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.FindCoordinator.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.FindCoordinator.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.FindCoordinator.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.FindCoordinator.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.FindCoordinator.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.FindCoordinator.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.FindCoordinator.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.FindCoordinator.V0.Response.t/0","doc":"Response struct for the Kafka `find_coordinator` API v0","ref":"Kayrock.FindCoordinator.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.FindCoordinator.V1.Request","doc":"Kayrock-generated request struct for Kafka `find_coordinator` v1 API\nmessages\n\nThe schema of this API is\n```\n[coordinator_key: :string, coordinator_type: :int8]\n```","ref":"Kayrock.FindCoordinator.V1.Request.html"},{"type":"function","title":"Kayrock.FindCoordinator.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.FindCoordinator.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.FindCoordinator.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.FindCoordinator.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.FindCoordinator.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.FindCoordinator.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.FindCoordinator.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.FindCoordinator.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.FindCoordinator.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.FindCoordinator.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.FindCoordinator.V1.Request.t/0","doc":"Request struct for the Kafka `find_coordinator` API v1","ref":"Kayrock.FindCoordinator.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.FindCoordinator.V1.Response","doc":"Kayrock-generated response struct for Kafka `find_coordinator` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  error_code: :int16,\n  error_message: :nullable_string,\n  coordinator: [node_id: :int32, host: :string, port: :int32]\n]\n```","ref":"Kayrock.FindCoordinator.V1.Response.html"},{"type":"function","title":"Kayrock.FindCoordinator.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.FindCoordinator.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.FindCoordinator.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.FindCoordinator.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.FindCoordinator.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.FindCoordinator.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.FindCoordinator.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.FindCoordinator.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.FindCoordinator.V1.Response.t/0","doc":"Response struct for the Kafka `find_coordinator` API v1","ref":"Kayrock.FindCoordinator.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Generate","doc":"Macros for generating modules for the protocol schema","ref":"Kayrock.Generate.html"},{"type":"function","title":"Kayrock.Generate.build_all/2","doc":"","ref":"Kayrock.Generate.html#build_all/2"},{"type":"function","title":"Kayrock.Generate.build_modules/3","doc":"","ref":"Kayrock.Generate.html#build_modules/3"},{"type":"function","title":"Kayrock.Generate.describe_type/3","doc":"","ref":"Kayrock.Generate.html#describe_type/3"},{"type":"function","title":"Kayrock.Generate.generate_field_deserializer/3","doc":"","ref":"Kayrock.Generate.html#generate_field_deserializer/3"},{"type":"function","title":"Kayrock.Generate.generate_request_struct/5","doc":"","ref":"Kayrock.Generate.html#generate_request_struct/5"},{"type":"function","title":"Kayrock.Generate.generate_response_struct/4","doc":"","ref":"Kayrock.Generate.html#generate_response_struct/4"},{"type":"function","title":"Kayrock.Generate.generate_schema_metadata/1","doc":"","ref":"Kayrock.Generate.html#generate_schema_metadata/1"},{"type":"function","title":"Kayrock.Generate.generate_serializer/1","doc":"","ref":"Kayrock.Generate.html#generate_serializer/1"},{"type":"function","title":"Kayrock.Generate.make_request_getter/1","doc":"","ref":"Kayrock.Generate.html#make_request_getter/1"},{"type":"function","title":"Kayrock.Generate.make_request_module/3","doc":"","ref":"Kayrock.Generate.html#make_request_module/3"},{"type":"function","title":"Kayrock.Generate.make_response_deserializer/1","doc":"","ref":"Kayrock.Generate.html#make_response_deserializer/1"},{"type":"function","title":"Kayrock.Generate.make_response_module/3","doc":"","ref":"Kayrock.Generate.html#make_response_module/3"},{"type":"function","title":"Kayrock.Generate.make_types/3","doc":"","ref":"Kayrock.Generate.html#make_types/3"},{"type":"module","title":"Kayrock.GroupProtocolMetadata","doc":"Code to serialize consumer group ProtocolMetadata messages\n\nSee https://cwiki.apache.org/confluence/display/KAFKA/A+Guide+To+The+Kafka+Protocol#AGuideToTheKafkaProtocol-JoinGroupRequest","ref":"Kayrock.GroupProtocolMetadata.html"},{"type":"function","title":"Kayrock.GroupProtocolMetadata.serialize/1","doc":"","ref":"Kayrock.GroupProtocolMetadata.html#serialize/1"},{"type":"module","title":"Kayrock.Heartbeat","doc":"Kayrock-generated module for the Kafka `heartbeat` API","ref":"Kayrock.Heartbeat.html"},{"type":"function","title":"Kayrock.Heartbeat.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.Heartbeat.html#deserialize/2"},{"type":"function","title":"Kayrock.Heartbeat.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.Heartbeat.html#get_request_struct/1"},{"type":"function","title":"Kayrock.Heartbeat.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (1)","ref":"Kayrock.Heartbeat.html#max_vsn/0"},{"type":"function","title":"Kayrock.Heartbeat.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.Heartbeat.html#min_vsn/0"},{"type":"type","title":"Kayrock.Heartbeat.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.Heartbeat.html#t:request_t/0"},{"type":"type","title":"Kayrock.Heartbeat.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.Heartbeat.html#t:response_t/0"},{"type":"module","title":"Kayrock.Heartbeat.V0.Request","doc":"Kayrock-generated request struct for Kafka `heartbeat` v0 API\nmessages\n\nThe schema of this API is\n```\n[group_id: :string, generation_id: :int32, member_id: :string]\n```","ref":"Kayrock.Heartbeat.V0.Request.html"},{"type":"function","title":"Kayrock.Heartbeat.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Heartbeat.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Heartbeat.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.Heartbeat.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Heartbeat.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Heartbeat.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Heartbeat.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Heartbeat.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.Heartbeat.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Heartbeat.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Heartbeat.V0.Request.t/0","doc":"Request struct for the Kafka `heartbeat` API v0","ref":"Kayrock.Heartbeat.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Heartbeat.V0.Response","doc":"Kayrock-generated response struct for Kafka `heartbeat` v0 API\nmessages\n\nThe schema of this API is\n```\n[error_code: :int16]\n```","ref":"Kayrock.Heartbeat.V0.Response.html"},{"type":"function","title":"Kayrock.Heartbeat.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Heartbeat.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Heartbeat.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.Heartbeat.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Heartbeat.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Heartbeat.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Heartbeat.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Heartbeat.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.Heartbeat.V0.Response.t/0","doc":"Response struct for the Kafka `heartbeat` API v0","ref":"Kayrock.Heartbeat.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Heartbeat.V1.Request","doc":"Kayrock-generated request struct for Kafka `heartbeat` v1 API\nmessages\n\nThe schema of this API is\n```\n[group_id: :string, generation_id: :int32, member_id: :string]\n```","ref":"Kayrock.Heartbeat.V1.Request.html"},{"type":"function","title":"Kayrock.Heartbeat.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Heartbeat.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Heartbeat.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.Heartbeat.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Heartbeat.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Heartbeat.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Heartbeat.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Heartbeat.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.Heartbeat.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Heartbeat.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Heartbeat.V1.Request.t/0","doc":"Request struct for the Kafka `heartbeat` API v1","ref":"Kayrock.Heartbeat.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Heartbeat.V1.Response","doc":"Kayrock-generated response struct for Kafka `heartbeat` v1 API\nmessages\n\nThe schema of this API is\n```\n[throttle_time_ms: :int32, error_code: :int16]\n```","ref":"Kayrock.Heartbeat.V1.Response.html"},{"type":"function","title":"Kayrock.Heartbeat.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Heartbeat.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Heartbeat.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.Heartbeat.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Heartbeat.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Heartbeat.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Heartbeat.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Heartbeat.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.Heartbeat.V1.Response.t/0","doc":"Response struct for the Kafka `heartbeat` API v1","ref":"Kayrock.Heartbeat.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.InitProducerId","doc":"Kayrock-generated module for the Kafka `init_producer_id` API","ref":"Kayrock.InitProducerId.html"},{"type":"function","title":"Kayrock.InitProducerId.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.InitProducerId.html#deserialize/2"},{"type":"function","title":"Kayrock.InitProducerId.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.InitProducerId.html#get_request_struct/1"},{"type":"function","title":"Kayrock.InitProducerId.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.InitProducerId.html#max_vsn/0"},{"type":"function","title":"Kayrock.InitProducerId.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.InitProducerId.html#min_vsn/0"},{"type":"type","title":"Kayrock.InitProducerId.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.InitProducerId.html#t:request_t/0"},{"type":"type","title":"Kayrock.InitProducerId.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.InitProducerId.html#t:response_t/0"},{"type":"module","title":"Kayrock.InitProducerId.V0.Request","doc":"Kayrock-generated request struct for Kafka `init_producer_id` v0 API\nmessages\n\nThe schema of this API is\n```\n[transactional_id: :nullable_string, transaction_timeout_ms: :int32]\n```","ref":"Kayrock.InitProducerId.V0.Request.html"},{"type":"function","title":"Kayrock.InitProducerId.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.InitProducerId.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.InitProducerId.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.InitProducerId.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.InitProducerId.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.InitProducerId.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.InitProducerId.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.InitProducerId.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.InitProducerId.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.InitProducerId.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.InitProducerId.V0.Request.t/0","doc":"Request struct for the Kafka `init_producer_id` API v0","ref":"Kayrock.InitProducerId.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.InitProducerId.V0.Response","doc":"Kayrock-generated response struct for Kafka `init_producer_id` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  error_code: :int16,\n  producer_id: :int64,\n  producer_epoch: :int16\n]\n```","ref":"Kayrock.InitProducerId.V0.Response.html"},{"type":"function","title":"Kayrock.InitProducerId.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.InitProducerId.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.InitProducerId.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.InitProducerId.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.InitProducerId.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.InitProducerId.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.InitProducerId.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.InitProducerId.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.InitProducerId.V0.Response.t/0","doc":"Response struct for the Kafka `init_producer_id` API v0","ref":"Kayrock.InitProducerId.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.JoinGroup","doc":"Kayrock-generated module for the Kafka `join_group` API","ref":"Kayrock.JoinGroup.html"},{"type":"function","title":"Kayrock.JoinGroup.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.JoinGroup.html#deserialize/2"},{"type":"function","title":"Kayrock.JoinGroup.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.JoinGroup.html#get_request_struct/1"},{"type":"function","title":"Kayrock.JoinGroup.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (2)","ref":"Kayrock.JoinGroup.html#max_vsn/0"},{"type":"function","title":"Kayrock.JoinGroup.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.JoinGroup.html#min_vsn/0"},{"type":"type","title":"Kayrock.JoinGroup.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.JoinGroup.html#t:request_t/0"},{"type":"type","title":"Kayrock.JoinGroup.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.JoinGroup.html#t:response_t/0"},{"type":"module","title":"Kayrock.JoinGroup.V0.Request","doc":"Kayrock-generated request struct for Kafka `join_group` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  session_timeout: :int32,\n  member_id: :string,\n  protocol_type: :string,\n  group_protocols: {:array, [protocol_name: :string, protocol_metadata: :bytes]}\n]\n```","ref":"Kayrock.JoinGroup.V0.Request.html"},{"type":"function","title":"Kayrock.JoinGroup.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.JoinGroup.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.JoinGroup.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.JoinGroup.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.JoinGroup.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.JoinGroup.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.JoinGroup.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.JoinGroup.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.JoinGroup.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.JoinGroup.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.JoinGroup.V0.Request.t/0","doc":"Request struct for the Kafka `join_group` API v0","ref":"Kayrock.JoinGroup.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.JoinGroup.V0.Response","doc":"Kayrock-generated response struct for Kafka `join_group` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  error_code: :int16,\n  generation_id: :int32,\n  group_protocol: :string,\n  leader_id: :string,\n  member_id: :string,\n  members: {:array, [member_id: :string, member_metadata: :bytes]}\n]\n```","ref":"Kayrock.JoinGroup.V0.Response.html"},{"type":"function","title":"Kayrock.JoinGroup.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.JoinGroup.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.JoinGroup.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.JoinGroup.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.JoinGroup.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.JoinGroup.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.JoinGroup.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.JoinGroup.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.JoinGroup.V0.Response.t/0","doc":"Response struct for the Kafka `join_group` API v0","ref":"Kayrock.JoinGroup.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.JoinGroup.V1.Request","doc":"Kayrock-generated request struct for Kafka `join_group` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  session_timeout: :int32,\n  rebalance_timeout: :int32,\n  member_id: :string,\n  protocol_type: :string,\n  group_protocols: {:array, [protocol_name: :string, protocol_metadata: :bytes]}\n]\n```","ref":"Kayrock.JoinGroup.V1.Request.html"},{"type":"function","title":"Kayrock.JoinGroup.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.JoinGroup.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.JoinGroup.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.JoinGroup.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.JoinGroup.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.JoinGroup.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.JoinGroup.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.JoinGroup.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.JoinGroup.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.JoinGroup.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.JoinGroup.V1.Request.t/0","doc":"Request struct for the Kafka `join_group` API v1","ref":"Kayrock.JoinGroup.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.JoinGroup.V1.Response","doc":"Kayrock-generated response struct for Kafka `join_group` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  error_code: :int16,\n  generation_id: :int32,\n  group_protocol: :string,\n  leader_id: :string,\n  member_id: :string,\n  members: {:array, [member_id: :string, member_metadata: :bytes]}\n]\n```","ref":"Kayrock.JoinGroup.V1.Response.html"},{"type":"function","title":"Kayrock.JoinGroup.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.JoinGroup.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.JoinGroup.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.JoinGroup.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.JoinGroup.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.JoinGroup.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.JoinGroup.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.JoinGroup.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.JoinGroup.V1.Response.t/0","doc":"Response struct for the Kafka `join_group` API v1","ref":"Kayrock.JoinGroup.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.JoinGroup.V2.Request","doc":"Kayrock-generated request struct for Kafka `join_group` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  session_timeout: :int32,\n  rebalance_timeout: :int32,\n  member_id: :string,\n  protocol_type: :string,\n  group_protocols: {:array, [protocol_name: :string, protocol_metadata: :bytes]}\n]\n```","ref":"Kayrock.JoinGroup.V2.Request.html"},{"type":"function","title":"Kayrock.JoinGroup.V2.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.JoinGroup.V2.Request.html#api_key/0"},{"type":"function","title":"Kayrock.JoinGroup.V2.Request.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.JoinGroup.V2.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.JoinGroup.V2.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.JoinGroup.V2.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.JoinGroup.V2.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.JoinGroup.V2.Request.html#schema/0"},{"type":"function","title":"Kayrock.JoinGroup.V2.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.JoinGroup.V2.Request.html#serialize/1"},{"type":"type","title":"Kayrock.JoinGroup.V2.Request.t/0","doc":"Request struct for the Kafka `join_group` API v2","ref":"Kayrock.JoinGroup.V2.Request.html#t:t/0"},{"type":"module","title":"Kayrock.JoinGroup.V2.Response","doc":"Kayrock-generated response struct for Kafka `join_group` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  error_code: :int16,\n  generation_id: :int32,\n  group_protocol: :string,\n  leader_id: :string,\n  member_id: :string,\n  members: {:array, [member_id: :string, member_metadata: :bytes]}\n]\n```","ref":"Kayrock.JoinGroup.V2.Response.html"},{"type":"function","title":"Kayrock.JoinGroup.V2.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.JoinGroup.V2.Response.html#api_key/0"},{"type":"function","title":"Kayrock.JoinGroup.V2.Response.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.JoinGroup.V2.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.JoinGroup.V2.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.JoinGroup.V2.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.JoinGroup.V2.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.JoinGroup.V2.Response.html#schema/0"},{"type":"type","title":"Kayrock.JoinGroup.V2.Response.t/0","doc":"Response struct for the Kafka `join_group` API v2","ref":"Kayrock.JoinGroup.V2.Response.html#t:t/0"},{"type":"module","title":"Kayrock.LeaveGroup","doc":"Kayrock-generated module for the Kafka `leave_group` API","ref":"Kayrock.LeaveGroup.html"},{"type":"function","title":"Kayrock.LeaveGroup.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.LeaveGroup.html#deserialize/2"},{"type":"function","title":"Kayrock.LeaveGroup.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.LeaveGroup.html#get_request_struct/1"},{"type":"function","title":"Kayrock.LeaveGroup.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (1)","ref":"Kayrock.LeaveGroup.html#max_vsn/0"},{"type":"function","title":"Kayrock.LeaveGroup.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.LeaveGroup.html#min_vsn/0"},{"type":"type","title":"Kayrock.LeaveGroup.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.LeaveGroup.html#t:request_t/0"},{"type":"type","title":"Kayrock.LeaveGroup.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.LeaveGroup.html#t:response_t/0"},{"type":"module","title":"Kayrock.LeaveGroup.V0.Request","doc":"Kayrock-generated request struct for Kafka `leave_group` v0 API\nmessages\n\nThe schema of this API is\n```\n[group_id: :string, member_id: :string]\n```","ref":"Kayrock.LeaveGroup.V0.Request.html"},{"type":"function","title":"Kayrock.LeaveGroup.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.LeaveGroup.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.LeaveGroup.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.LeaveGroup.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.LeaveGroup.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.LeaveGroup.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.LeaveGroup.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.LeaveGroup.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.LeaveGroup.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.LeaveGroup.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.LeaveGroup.V0.Request.t/0","doc":"Request struct for the Kafka `leave_group` API v0","ref":"Kayrock.LeaveGroup.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.LeaveGroup.V0.Response","doc":"Kayrock-generated response struct for Kafka `leave_group` v0 API\nmessages\n\nThe schema of this API is\n```\n[error_code: :int16]\n```","ref":"Kayrock.LeaveGroup.V0.Response.html"},{"type":"function","title":"Kayrock.LeaveGroup.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.LeaveGroup.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.LeaveGroup.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.LeaveGroup.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.LeaveGroup.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.LeaveGroup.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.LeaveGroup.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.LeaveGroup.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.LeaveGroup.V0.Response.t/0","doc":"Response struct for the Kafka `leave_group` API v0","ref":"Kayrock.LeaveGroup.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.LeaveGroup.V1.Request","doc":"Kayrock-generated request struct for Kafka `leave_group` v1 API\nmessages\n\nThe schema of this API is\n```\n[group_id: :string, member_id: :string]\n```","ref":"Kayrock.LeaveGroup.V1.Request.html"},{"type":"function","title":"Kayrock.LeaveGroup.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.LeaveGroup.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.LeaveGroup.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.LeaveGroup.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.LeaveGroup.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.LeaveGroup.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.LeaveGroup.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.LeaveGroup.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.LeaveGroup.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.LeaveGroup.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.LeaveGroup.V1.Request.t/0","doc":"Request struct for the Kafka `leave_group` API v1","ref":"Kayrock.LeaveGroup.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.LeaveGroup.V1.Response","doc":"Kayrock-generated response struct for Kafka `leave_group` v1 API\nmessages\n\nThe schema of this API is\n```\n[throttle_time_ms: :int32, error_code: :int16]\n```","ref":"Kayrock.LeaveGroup.V1.Response.html"},{"type":"function","title":"Kayrock.LeaveGroup.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.LeaveGroup.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.LeaveGroup.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.LeaveGroup.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.LeaveGroup.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.LeaveGroup.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.LeaveGroup.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.LeaveGroup.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.LeaveGroup.V1.Response.t/0","doc":"Response struct for the Kafka `leave_group` API v1","ref":"Kayrock.LeaveGroup.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.ListGroups","doc":"Kayrock-generated module for the Kafka `list_groups` API","ref":"Kayrock.ListGroups.html"},{"type":"function","title":"Kayrock.ListGroups.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.ListGroups.html#deserialize/2"},{"type":"function","title":"Kayrock.ListGroups.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.ListGroups.html#get_request_struct/1"},{"type":"function","title":"Kayrock.ListGroups.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (1)","ref":"Kayrock.ListGroups.html#max_vsn/0"},{"type":"function","title":"Kayrock.ListGroups.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.ListGroups.html#min_vsn/0"},{"type":"type","title":"Kayrock.ListGroups.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.ListGroups.html#t:request_t/0"},{"type":"type","title":"Kayrock.ListGroups.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.ListGroups.html#t:response_t/0"},{"type":"module","title":"Kayrock.ListGroups.V0.Request","doc":"Kayrock-generated request struct for Kafka `list_groups` v0 API\nmessages\n\nThe schema of this API is\n```\n[]\n```","ref":"Kayrock.ListGroups.V0.Request.html"},{"type":"function","title":"Kayrock.ListGroups.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ListGroups.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.ListGroups.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.ListGroups.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.ListGroups.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.ListGroups.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.ListGroups.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ListGroups.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.ListGroups.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.ListGroups.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.ListGroups.V0.Request.t/0","doc":"Request struct for the Kafka `list_groups` API v0","ref":"Kayrock.ListGroups.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.ListGroups.V0.Response","doc":"Kayrock-generated response struct for Kafka `list_groups` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  error_code: :int16,\n  groups: {:array, [group_id: :string, protocol_type: :string]}\n]\n```","ref":"Kayrock.ListGroups.V0.Response.html"},{"type":"function","title":"Kayrock.ListGroups.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ListGroups.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.ListGroups.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.ListGroups.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.ListGroups.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.ListGroups.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.ListGroups.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ListGroups.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.ListGroups.V0.Response.t/0","doc":"Response struct for the Kafka `list_groups` API v0","ref":"Kayrock.ListGroups.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.ListGroups.V1.Request","doc":"Kayrock-generated request struct for Kafka `list_groups` v1 API\nmessages\n\nThe schema of this API is\n```\n[]\n```","ref":"Kayrock.ListGroups.V1.Request.html"},{"type":"function","title":"Kayrock.ListGroups.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ListGroups.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.ListGroups.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.ListGroups.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.ListGroups.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.ListGroups.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.ListGroups.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ListGroups.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.ListGroups.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.ListGroups.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.ListGroups.V1.Request.t/0","doc":"Request struct for the Kafka `list_groups` API v1","ref":"Kayrock.ListGroups.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.ListGroups.V1.Response","doc":"Kayrock-generated response struct for Kafka `list_groups` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  error_code: :int16,\n  groups: {:array, [group_id: :string, protocol_type: :string]}\n]\n```","ref":"Kayrock.ListGroups.V1.Response.html"},{"type":"function","title":"Kayrock.ListGroups.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ListGroups.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.ListGroups.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.ListGroups.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.ListGroups.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.ListGroups.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.ListGroups.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ListGroups.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.ListGroups.V1.Response.t/0","doc":"Response struct for the Kafka `list_groups` API v1","ref":"Kayrock.ListGroups.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.ListOffsets","doc":"Kayrock-generated module for the Kafka `list_offsets` API","ref":"Kayrock.ListOffsets.html"},{"type":"function","title":"Kayrock.ListOffsets.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.ListOffsets.html#deserialize/2"},{"type":"function","title":"Kayrock.ListOffsets.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.ListOffsets.html#get_request_struct/1"},{"type":"function","title":"Kayrock.ListOffsets.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (2)","ref":"Kayrock.ListOffsets.html#max_vsn/0"},{"type":"function","title":"Kayrock.ListOffsets.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.ListOffsets.html#min_vsn/0"},{"type":"type","title":"Kayrock.ListOffsets.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.ListOffsets.html#t:request_t/0"},{"type":"type","title":"Kayrock.ListOffsets.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.ListOffsets.html#t:response_t/0"},{"type":"module","title":"Kayrock.ListOffsets.V0.Request","doc":"Kayrock-generated request struct for Kafka `list_offsets` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, timestamp: :int64, max_num_offsets: :int32]}\n   ]}\n]\n```","ref":"Kayrock.ListOffsets.V0.Request.html"},{"type":"function","title":"Kayrock.ListOffsets.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ListOffsets.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.ListOffsets.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.ListOffsets.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.ListOffsets.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.ListOffsets.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.ListOffsets.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ListOffsets.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.ListOffsets.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.ListOffsets.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.ListOffsets.V0.Request.t/0","doc":"Request struct for the Kafka `list_offsets` API v0","ref":"Kayrock.ListOffsets.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.ListOffsets.V0.Response","doc":"Kayrock-generated response struct for Kafka `list_offsets` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [partition: :int32, error_code: :int16, offsets: {:array, :int64}]}\n   ]}\n]\n```","ref":"Kayrock.ListOffsets.V0.Response.html"},{"type":"function","title":"Kayrock.ListOffsets.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ListOffsets.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.ListOffsets.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.ListOffsets.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.ListOffsets.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.ListOffsets.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.ListOffsets.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ListOffsets.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.ListOffsets.V0.Response.t/0","doc":"Response struct for the Kafka `list_offsets` API v0","ref":"Kayrock.ListOffsets.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.ListOffsets.V1.Request","doc":"Kayrock-generated request struct for Kafka `list_offsets` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array, [partition: :int32, timestamp: :int64]}\n   ]}\n]\n```","ref":"Kayrock.ListOffsets.V1.Request.html"},{"type":"function","title":"Kayrock.ListOffsets.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ListOffsets.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.ListOffsets.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.ListOffsets.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.ListOffsets.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.ListOffsets.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.ListOffsets.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ListOffsets.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.ListOffsets.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.ListOffsets.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.ListOffsets.V1.Request.t/0","doc":"Request struct for the Kafka `list_offsets` API v1","ref":"Kayrock.ListOffsets.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.ListOffsets.V1.Response","doc":"Kayrock-generated response struct for Kafka `list_offsets` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [partition: :int32, error_code: :int16, timestamp: :int64, offset: :int64]}\n   ]}\n]\n```","ref":"Kayrock.ListOffsets.V1.Response.html"},{"type":"function","title":"Kayrock.ListOffsets.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ListOffsets.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.ListOffsets.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.ListOffsets.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.ListOffsets.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.ListOffsets.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.ListOffsets.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ListOffsets.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.ListOffsets.V1.Response.t/0","doc":"Response struct for the Kafka `list_offsets` API v1","ref":"Kayrock.ListOffsets.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.ListOffsets.V2.Request","doc":"Kayrock-generated request struct for Kafka `list_offsets` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  replica_id: :int32,\n  isolation_level: :int8,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array, [partition: :int32, timestamp: :int64]}\n   ]}\n]\n```","ref":"Kayrock.ListOffsets.V2.Request.html"},{"type":"function","title":"Kayrock.ListOffsets.V2.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ListOffsets.V2.Request.html#api_key/0"},{"type":"function","title":"Kayrock.ListOffsets.V2.Request.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.ListOffsets.V2.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.ListOffsets.V2.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.ListOffsets.V2.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.ListOffsets.V2.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ListOffsets.V2.Request.html#schema/0"},{"type":"function","title":"Kayrock.ListOffsets.V2.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.ListOffsets.V2.Request.html#serialize/1"},{"type":"type","title":"Kayrock.ListOffsets.V2.Request.t/0","doc":"Request struct for the Kafka `list_offsets` API v2","ref":"Kayrock.ListOffsets.V2.Request.html#t:t/0"},{"type":"module","title":"Kayrock.ListOffsets.V2.Response","doc":"Kayrock-generated response struct for Kafka `list_offsets` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [partition: :int32, error_code: :int16, timestamp: :int64, offset: :int64]}\n   ]}\n]\n```","ref":"Kayrock.ListOffsets.V2.Response.html"},{"type":"function","title":"Kayrock.ListOffsets.V2.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.ListOffsets.V2.Response.html#api_key/0"},{"type":"function","title":"Kayrock.ListOffsets.V2.Response.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.ListOffsets.V2.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.ListOffsets.V2.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.ListOffsets.V2.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.ListOffsets.V2.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.ListOffsets.V2.Response.html#schema/0"},{"type":"type","title":"Kayrock.ListOffsets.V2.Response.t/0","doc":"Response struct for the Kafka `list_offsets` API v2","ref":"Kayrock.ListOffsets.V2.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Macros","doc":"Useful macros for kafka-related values\n\n`use Kayrock.Macros` is a convenient way to use these","ref":"Kayrock.Macros.html"},{"type":"macro","title":"Kayrock.Macros.earliest_offset/0","doc":"Timestamp to supply for the earliest offset","ref":"Kayrock.Macros.html#earliest_offset/0"},{"type":"macro","title":"Kayrock.Macros.full_isr_acks/0","doc":"Full ISR acks required on produce","ref":"Kayrock.Macros.html#full_isr_acks/0"},{"type":"macro","title":"Kayrock.Macros.latest_offset/0","doc":"Timestamp to supply for the latest offset","ref":"Kayrock.Macros.html#latest_offset/0"},{"type":"macro","title":"Kayrock.Macros.leader_ack/0","doc":"Only leader ack required on produce","ref":"Kayrock.Macros.html#leader_ack/0"},{"type":"macro","title":"Kayrock.Macros.no_acks/0","doc":"No acks required on produce","ref":"Kayrock.Macros.html#no_acks/0"},{"type":"macro","title":"Kayrock.Macros.no_error/0","doc":"The error code value indicating no error","ref":"Kayrock.Macros.html#no_error/0"},{"type":"module","title":"Kayrock.MemberAssignment","doc":"Code to serialize/deserialize Kafka consumer group member assignments\n\nSee https://cwiki.apache.org/confluence/display/KAFKA/A+Guide+To+The+Kafka+Protocol#AGuideToTheKafkaProtocol-SyncGroupRequest","ref":"Kayrock.MemberAssignment.html"},{"type":"function","title":"Kayrock.MemberAssignment.deserialize/1","doc":"","ref":"Kayrock.MemberAssignment.html#deserialize/1"},{"type":"function","title":"Kayrock.MemberAssignment.serialize/1","doc":"","ref":"Kayrock.MemberAssignment.html#serialize/1"},{"type":"type","title":"Kayrock.MemberAssignment.t/0","doc":"","ref":"Kayrock.MemberAssignment.html#t:t/0"},{"type":"module","title":"Kayrock.MemberAssignment.PartitionAssignment","doc":"Represents partition assignments for a specific topic","ref":"Kayrock.MemberAssignment.PartitionAssignment.html"},{"type":"type","title":"Kayrock.MemberAssignment.PartitionAssignment.t/0","doc":"","ref":"Kayrock.MemberAssignment.PartitionAssignment.html#t:t/0"},{"type":"module","title":"Kayrock.MessageSet","doc":"Represents a set of messages with the v0 or v1 format\n\nThis is the old format that KafkaEx supported\n\nSee https://kafka.apache.org/documentation/#recordbatch","ref":"Kayrock.MessageSet.html"},{"type":"function","title":"Kayrock.MessageSet.deserialize/1","doc":"","ref":"Kayrock.MessageSet.html#deserialize/1"},{"type":"function","title":"Kayrock.MessageSet.deserialize/2","doc":"","ref":"Kayrock.MessageSet.html#deserialize/2"},{"type":"function","title":"Kayrock.MessageSet.serialize/1","doc":"","ref":"Kayrock.MessageSet.html#serialize/1"},{"type":"type","title":"Kayrock.MessageSet.t/0","doc":"","ref":"Kayrock.MessageSet.html#t:t/0"},{"type":"module","title":"Kayrock.MessageSet.Message","doc":"Represents a single message with the v0 or v1 format\n\nThis is the old format that KafkaEx supported\n\nSee https://kafka.apache.org/documentation/#recordbatch","ref":"Kayrock.MessageSet.Message.html"},{"type":"type","title":"Kayrock.MessageSet.Message.t/0","doc":"","ref":"Kayrock.MessageSet.Message.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata","doc":"Kayrock-generated module for the Kafka `metadata` API","ref":"Kayrock.Metadata.html"},{"type":"function","title":"Kayrock.Metadata.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.Metadata.html#deserialize/2"},{"type":"function","title":"Kayrock.Metadata.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.Metadata.html#get_request_struct/1"},{"type":"function","title":"Kayrock.Metadata.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (5)","ref":"Kayrock.Metadata.html#max_vsn/0"},{"type":"function","title":"Kayrock.Metadata.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.Metadata.html#min_vsn/0"},{"type":"type","title":"Kayrock.Metadata.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.Metadata.html#t:request_t/0"},{"type":"type","title":"Kayrock.Metadata.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.Metadata.html#t:response_t/0"},{"type":"module","title":"Kayrock.Metadata.V0.Request","doc":"Kayrock-generated request struct for Kafka `metadata` v0 API\nmessages\n\nThe schema of this API is\n```\n[topics: {:array, :string}]\n```","ref":"Kayrock.Metadata.V0.Request.html"},{"type":"function","title":"Kayrock.Metadata.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.Metadata.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Metadata.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Metadata.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.Metadata.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Metadata.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Metadata.V0.Request.t/0","doc":"Request struct for the Kafka `metadata` API v0","ref":"Kayrock.Metadata.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V0.Response","doc":"Kayrock-generated response struct for Kafka `metadata` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  brokers: {:array, [node_id: :int32, host: :string, port: :int32]},\n  topic_metadata: {:array,\n   [\n     error_code: :int16,\n     topic: :string,\n     partition_metadata: {:array,\n      [\n        error_code: :int16,\n        partition: :int32,\n        leader: :int32,\n        replicas: {:array, :int32},\n        isr: {:array, :int32}\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Metadata.V0.Response.html"},{"type":"function","title":"Kayrock.Metadata.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.Metadata.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Metadata.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Metadata.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.Metadata.V0.Response.t/0","doc":"Response struct for the Kafka `metadata` API v0","ref":"Kayrock.Metadata.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V1.Request","doc":"Kayrock-generated request struct for Kafka `metadata` v1 API\nmessages\n\nThe schema of this API is\n```\n[topics: {:array, :string}]\n```","ref":"Kayrock.Metadata.V1.Request.html"},{"type":"function","title":"Kayrock.Metadata.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.Metadata.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Metadata.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Metadata.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.Metadata.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Metadata.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Metadata.V1.Request.t/0","doc":"Request struct for the Kafka `metadata` API v1","ref":"Kayrock.Metadata.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V1.Response","doc":"Kayrock-generated response struct for Kafka `metadata` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  brokers: {:array,\n   [node_id: :int32, host: :string, port: :int32, rack: :nullable_string]},\n  controller_id: :int32,\n  topic_metadata: {:array,\n   [\n     error_code: :int16,\n     topic: :string,\n     is_internal: :boolean,\n     partition_metadata: {:array,\n      [\n        error_code: :int16,\n        partition: :int32,\n        leader: :int32,\n        replicas: {:array, :int32},\n        isr: {:array, :int32}\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Metadata.V1.Response.html"},{"type":"function","title":"Kayrock.Metadata.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.Metadata.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Metadata.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Metadata.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.Metadata.V1.Response.t/0","doc":"Response struct for the Kafka `metadata` API v1","ref":"Kayrock.Metadata.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V2.Request","doc":"Kayrock-generated request struct for Kafka `metadata` v2 API\nmessages\n\nThe schema of this API is\n```\n[topics: {:array, :string}]\n```","ref":"Kayrock.Metadata.V2.Request.html"},{"type":"function","title":"Kayrock.Metadata.V2.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V2.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V2.Request.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.Metadata.V2.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V2.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Metadata.V2.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Metadata.V2.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V2.Request.html#schema/0"},{"type":"function","title":"Kayrock.Metadata.V2.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Metadata.V2.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Metadata.V2.Request.t/0","doc":"Request struct for the Kafka `metadata` API v2","ref":"Kayrock.Metadata.V2.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V2.Response","doc":"Kayrock-generated response struct for Kafka `metadata` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  brokers: {:array,\n   [node_id: :int32, host: :string, port: :int32, rack: :nullable_string]},\n  cluster_id: :nullable_string,\n  controller_id: :int32,\n  topic_metadata: {:array,\n   [\n     error_code: :int16,\n     topic: :string,\n     is_internal: :boolean,\n     partition_metadata: {:array,\n      [\n        error_code: :int16,\n        partition: :int32,\n        leader: :int32,\n        replicas: {:array, :int32},\n        isr: {:array, :int32}\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Metadata.V2.Response.html"},{"type":"function","title":"Kayrock.Metadata.V2.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V2.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V2.Response.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.Metadata.V2.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V2.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Metadata.V2.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Metadata.V2.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V2.Response.html#schema/0"},{"type":"type","title":"Kayrock.Metadata.V2.Response.t/0","doc":"Response struct for the Kafka `metadata` API v2","ref":"Kayrock.Metadata.V2.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V3.Request","doc":"Kayrock-generated request struct for Kafka `metadata` v3 API\nmessages\n\nThe schema of this API is\n```\n[topics: {:array, :string}]\n```","ref":"Kayrock.Metadata.V3.Request.html"},{"type":"function","title":"Kayrock.Metadata.V3.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V3.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V3.Request.api_vsn/0","doc":"Returns the API version (3) implemented by this module","ref":"Kayrock.Metadata.V3.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V3.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Metadata.V3.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Metadata.V3.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V3.Request.html#schema/0"},{"type":"function","title":"Kayrock.Metadata.V3.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Metadata.V3.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Metadata.V3.Request.t/0","doc":"Request struct for the Kafka `metadata` API v3","ref":"Kayrock.Metadata.V3.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V3.Response","doc":"Kayrock-generated response struct for Kafka `metadata` v3 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  brokers: {:array,\n   [node_id: :int32, host: :string, port: :int32, rack: :nullable_string]},\n  cluster_id: :nullable_string,\n  controller_id: :int32,\n  topic_metadata: {:array,\n   [\n     error_code: :int16,\n     topic: :string,\n     is_internal: :boolean,\n     partition_metadata: {:array,\n      [\n        error_code: :int16,\n        partition: :int32,\n        leader: :int32,\n        replicas: {:array, :int32},\n        isr: {:array, :int32}\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Metadata.V3.Response.html"},{"type":"function","title":"Kayrock.Metadata.V3.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V3.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V3.Response.api_vsn/0","doc":"Returns the API version (3) implemented by this module","ref":"Kayrock.Metadata.V3.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V3.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Metadata.V3.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Metadata.V3.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V3.Response.html#schema/0"},{"type":"type","title":"Kayrock.Metadata.V3.Response.t/0","doc":"Response struct for the Kafka `metadata` API v3","ref":"Kayrock.Metadata.V3.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V4.Request","doc":"Kayrock-generated request struct for Kafka `metadata` v4 API\nmessages\n\nThe schema of this API is\n```\n[topics: {:array, :string}, allow_auto_topic_creation: :boolean]\n```","ref":"Kayrock.Metadata.V4.Request.html"},{"type":"function","title":"Kayrock.Metadata.V4.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V4.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V4.Request.api_vsn/0","doc":"Returns the API version (4) implemented by this module","ref":"Kayrock.Metadata.V4.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V4.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Metadata.V4.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Metadata.V4.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V4.Request.html#schema/0"},{"type":"function","title":"Kayrock.Metadata.V4.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Metadata.V4.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Metadata.V4.Request.t/0","doc":"Request struct for the Kafka `metadata` API v4","ref":"Kayrock.Metadata.V4.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V4.Response","doc":"Kayrock-generated response struct for Kafka `metadata` v4 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  brokers: {:array,\n   [node_id: :int32, host: :string, port: :int32, rack: :nullable_string]},\n  cluster_id: :nullable_string,\n  controller_id: :int32,\n  topic_metadata: {:array,\n   [\n     error_code: :int16,\n     topic: :string,\n     is_internal: :boolean,\n     partition_metadata: {:array,\n      [\n        error_code: :int16,\n        partition: :int32,\n        leader: :int32,\n        replicas: {:array, :int32},\n        isr: {:array, :int32}\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Metadata.V4.Response.html"},{"type":"function","title":"Kayrock.Metadata.V4.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V4.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V4.Response.api_vsn/0","doc":"Returns the API version (4) implemented by this module","ref":"Kayrock.Metadata.V4.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V4.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Metadata.V4.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Metadata.V4.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V4.Response.html#schema/0"},{"type":"type","title":"Kayrock.Metadata.V4.Response.t/0","doc":"Response struct for the Kafka `metadata` API v4","ref":"Kayrock.Metadata.V4.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V5.Request","doc":"Kayrock-generated request struct for Kafka `metadata` v5 API\nmessages\n\nThe schema of this API is\n```\n[topics: {:array, :string}, allow_auto_topic_creation: :boolean]\n```","ref":"Kayrock.Metadata.V5.Request.html"},{"type":"function","title":"Kayrock.Metadata.V5.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V5.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V5.Request.api_vsn/0","doc":"Returns the API version (5) implemented by this module","ref":"Kayrock.Metadata.V5.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V5.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Metadata.V5.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Metadata.V5.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V5.Request.html#schema/0"},{"type":"function","title":"Kayrock.Metadata.V5.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Metadata.V5.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Metadata.V5.Request.t/0","doc":"Request struct for the Kafka `metadata` API v5","ref":"Kayrock.Metadata.V5.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Metadata.V5.Response","doc":"Kayrock-generated response struct for Kafka `metadata` v5 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  brokers: {:array,\n   [node_id: :int32, host: :string, port: :int32, rack: :nullable_string]},\n  cluster_id: :nullable_string,\n  controller_id: :int32,\n  topic_metadata: {:array,\n   [\n     error_code: :int16,\n     topic: :string,\n     is_internal: :boolean,\n     partition_metadata: {:array,\n      [\n        error_code: :int16,\n        partition: :int32,\n        leader: :int32,\n        replicas: {:array, :int32},\n        isr: {:array, :int32},\n        offline_replicas: {:array, :int32}\n      ]}\n   ]}\n]\n```","ref":"Kayrock.Metadata.V5.Response.html"},{"type":"function","title":"Kayrock.Metadata.V5.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Metadata.V5.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Metadata.V5.Response.api_vsn/0","doc":"Returns the API version (5) implemented by this module","ref":"Kayrock.Metadata.V5.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Metadata.V5.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Metadata.V5.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Metadata.V5.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Metadata.V5.Response.html#schema/0"},{"type":"type","title":"Kayrock.Metadata.V5.Response.t/0","doc":"Response struct for the Kafka `metadata` API v5","ref":"Kayrock.Metadata.V5.Response.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetCommit","doc":"Kayrock-generated module for the Kafka `offset_commit` API","ref":"Kayrock.OffsetCommit.html"},{"type":"function","title":"Kayrock.OffsetCommit.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.OffsetCommit.html#deserialize/2"},{"type":"function","title":"Kayrock.OffsetCommit.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.OffsetCommit.html#get_request_struct/1"},{"type":"function","title":"Kayrock.OffsetCommit.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (3)","ref":"Kayrock.OffsetCommit.html#max_vsn/0"},{"type":"function","title":"Kayrock.OffsetCommit.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.OffsetCommit.html#min_vsn/0"},{"type":"type","title":"Kayrock.OffsetCommit.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.OffsetCommit.html#t:request_t/0"},{"type":"type","title":"Kayrock.OffsetCommit.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.OffsetCommit.html#t:response_t/0"},{"type":"module","title":"Kayrock.OffsetCommit.V0.Request","doc":"Kayrock-generated request struct for Kafka `offset_commit` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, offset: :int64, metadata: :nullable_string]}\n   ]}\n]\n```","ref":"Kayrock.OffsetCommit.V0.Request.html"},{"type":"function","title":"Kayrock.OffsetCommit.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetCommit.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetCommit.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.OffsetCommit.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetCommit.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.OffsetCommit.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.OffsetCommit.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetCommit.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.OffsetCommit.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.OffsetCommit.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.OffsetCommit.V0.Request.t/0","doc":"Request struct for the Kafka `offset_commit` API v0","ref":"Kayrock.OffsetCommit.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetCommit.V0.Response","doc":"Kayrock-generated response struct for Kafka `offset_commit` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array, [partition: :int32, error_code: :int16]}\n   ]}\n]\n```","ref":"Kayrock.OffsetCommit.V0.Response.html"},{"type":"function","title":"Kayrock.OffsetCommit.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetCommit.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetCommit.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.OffsetCommit.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetCommit.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.OffsetCommit.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.OffsetCommit.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetCommit.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.OffsetCommit.V0.Response.t/0","doc":"Response struct for the Kafka `offset_commit` API v0","ref":"Kayrock.OffsetCommit.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetCommit.V1.Request","doc":"Kayrock-generated request struct for Kafka `offset_commit` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  generation_id: :int32,\n  member_id: :string,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [\n        partition: :int32,\n        offset: :int64,\n        timestamp: :int64,\n        metadata: :nullable_string\n      ]}\n   ]}\n]\n```","ref":"Kayrock.OffsetCommit.V1.Request.html"},{"type":"function","title":"Kayrock.OffsetCommit.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetCommit.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetCommit.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.OffsetCommit.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetCommit.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.OffsetCommit.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.OffsetCommit.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetCommit.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.OffsetCommit.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.OffsetCommit.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.OffsetCommit.V1.Request.t/0","doc":"Request struct for the Kafka `offset_commit` API v1","ref":"Kayrock.OffsetCommit.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetCommit.V1.Response","doc":"Kayrock-generated response struct for Kafka `offset_commit` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array, [partition: :int32, error_code: :int16]}\n   ]}\n]\n```","ref":"Kayrock.OffsetCommit.V1.Response.html"},{"type":"function","title":"Kayrock.OffsetCommit.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetCommit.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetCommit.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.OffsetCommit.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetCommit.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.OffsetCommit.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.OffsetCommit.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetCommit.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.OffsetCommit.V1.Response.t/0","doc":"Response struct for the Kafka `offset_commit` API v1","ref":"Kayrock.OffsetCommit.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetCommit.V2.Request","doc":"Kayrock-generated request struct for Kafka `offset_commit` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  generation_id: :int32,\n  member_id: :string,\n  retention_time: :int64,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, offset: :int64, metadata: :nullable_string]}\n   ]}\n]\n```","ref":"Kayrock.OffsetCommit.V2.Request.html"},{"type":"function","title":"Kayrock.OffsetCommit.V2.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetCommit.V2.Request.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetCommit.V2.Request.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.OffsetCommit.V2.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetCommit.V2.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.OffsetCommit.V2.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.OffsetCommit.V2.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetCommit.V2.Request.html#schema/0"},{"type":"function","title":"Kayrock.OffsetCommit.V2.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.OffsetCommit.V2.Request.html#serialize/1"},{"type":"type","title":"Kayrock.OffsetCommit.V2.Request.t/0","doc":"Request struct for the Kafka `offset_commit` API v2","ref":"Kayrock.OffsetCommit.V2.Request.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetCommit.V2.Response","doc":"Kayrock-generated response struct for Kafka `offset_commit` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array, [partition: :int32, error_code: :int16]}\n   ]}\n]\n```","ref":"Kayrock.OffsetCommit.V2.Response.html"},{"type":"function","title":"Kayrock.OffsetCommit.V2.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetCommit.V2.Response.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetCommit.V2.Response.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.OffsetCommit.V2.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetCommit.V2.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.OffsetCommit.V2.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.OffsetCommit.V2.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetCommit.V2.Response.html#schema/0"},{"type":"type","title":"Kayrock.OffsetCommit.V2.Response.t/0","doc":"Response struct for the Kafka `offset_commit` API v2","ref":"Kayrock.OffsetCommit.V2.Response.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetCommit.V3.Request","doc":"Kayrock-generated request struct for Kafka `offset_commit` v3 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  generation_id: :int32,\n  member_id: :string,\n  retention_time: :int64,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, offset: :int64, metadata: :nullable_string]}\n   ]}\n]\n```","ref":"Kayrock.OffsetCommit.V3.Request.html"},{"type":"function","title":"Kayrock.OffsetCommit.V3.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetCommit.V3.Request.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetCommit.V3.Request.api_vsn/0","doc":"Returns the API version (3) implemented by this module","ref":"Kayrock.OffsetCommit.V3.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetCommit.V3.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.OffsetCommit.V3.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.OffsetCommit.V3.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetCommit.V3.Request.html#schema/0"},{"type":"function","title":"Kayrock.OffsetCommit.V3.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.OffsetCommit.V3.Request.html#serialize/1"},{"type":"type","title":"Kayrock.OffsetCommit.V3.Request.t/0","doc":"Request struct for the Kafka `offset_commit` API v3","ref":"Kayrock.OffsetCommit.V3.Request.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetCommit.V3.Response","doc":"Kayrock-generated response struct for Kafka `offset_commit` v3 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array, [partition: :int32, error_code: :int16]}\n   ]}\n]\n```","ref":"Kayrock.OffsetCommit.V3.Response.html"},{"type":"function","title":"Kayrock.OffsetCommit.V3.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetCommit.V3.Response.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetCommit.V3.Response.api_vsn/0","doc":"Returns the API version (3) implemented by this module","ref":"Kayrock.OffsetCommit.V3.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetCommit.V3.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.OffsetCommit.V3.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.OffsetCommit.V3.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetCommit.V3.Response.html#schema/0"},{"type":"type","title":"Kayrock.OffsetCommit.V3.Response.t/0","doc":"Response struct for the Kafka `offset_commit` API v3","ref":"Kayrock.OffsetCommit.V3.Response.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetFetch","doc":"Kayrock-generated module for the Kafka `offset_fetch` API","ref":"Kayrock.OffsetFetch.html"},{"type":"function","title":"Kayrock.OffsetFetch.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.OffsetFetch.html#deserialize/2"},{"type":"function","title":"Kayrock.OffsetFetch.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.OffsetFetch.html#get_request_struct/1"},{"type":"function","title":"Kayrock.OffsetFetch.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (3)","ref":"Kayrock.OffsetFetch.html#max_vsn/0"},{"type":"function","title":"Kayrock.OffsetFetch.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.OffsetFetch.html#min_vsn/0"},{"type":"type","title":"Kayrock.OffsetFetch.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.OffsetFetch.html#t:request_t/0"},{"type":"type","title":"Kayrock.OffsetFetch.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.OffsetFetch.html#t:response_t/0"},{"type":"module","title":"Kayrock.OffsetFetch.V0.Request","doc":"Kayrock-generated request struct for Kafka `offset_fetch` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  topics: {:array, [topic: :string, partitions: {:array, [partition: :int32]}]}\n]\n```","ref":"Kayrock.OffsetFetch.V0.Request.html"},{"type":"function","title":"Kayrock.OffsetFetch.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetFetch.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetFetch.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.OffsetFetch.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetFetch.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.OffsetFetch.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.OffsetFetch.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetFetch.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.OffsetFetch.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.OffsetFetch.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.OffsetFetch.V0.Request.t/0","doc":"Request struct for the Kafka `offset_fetch` API v0","ref":"Kayrock.OffsetFetch.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetFetch.V0.Response","doc":"Kayrock-generated response struct for Kafka `offset_fetch` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition: :int32,\n        offset: :int64,\n        metadata: :nullable_string,\n        error_code: :int16\n      ]}\n   ]}\n]\n```","ref":"Kayrock.OffsetFetch.V0.Response.html"},{"type":"function","title":"Kayrock.OffsetFetch.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetFetch.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetFetch.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.OffsetFetch.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetFetch.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.OffsetFetch.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.OffsetFetch.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetFetch.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.OffsetFetch.V0.Response.t/0","doc":"Response struct for the Kafka `offset_fetch` API v0","ref":"Kayrock.OffsetFetch.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetFetch.V1.Request","doc":"Kayrock-generated request struct for Kafka `offset_fetch` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  topics: {:array, [topic: :string, partitions: {:array, [partition: :int32]}]}\n]\n```","ref":"Kayrock.OffsetFetch.V1.Request.html"},{"type":"function","title":"Kayrock.OffsetFetch.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetFetch.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetFetch.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.OffsetFetch.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetFetch.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.OffsetFetch.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.OffsetFetch.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetFetch.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.OffsetFetch.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.OffsetFetch.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.OffsetFetch.V1.Request.t/0","doc":"Request struct for the Kafka `offset_fetch` API v1","ref":"Kayrock.OffsetFetch.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetFetch.V1.Response","doc":"Kayrock-generated response struct for Kafka `offset_fetch` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition: :int32,\n        offset: :int64,\n        metadata: :nullable_string,\n        error_code: :int16\n      ]}\n   ]}\n]\n```","ref":"Kayrock.OffsetFetch.V1.Response.html"},{"type":"function","title":"Kayrock.OffsetFetch.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetFetch.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetFetch.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.OffsetFetch.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetFetch.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.OffsetFetch.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.OffsetFetch.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetFetch.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.OffsetFetch.V1.Response.t/0","doc":"Response struct for the Kafka `offset_fetch` API v1","ref":"Kayrock.OffsetFetch.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetFetch.V2.Request","doc":"Kayrock-generated request struct for Kafka `offset_fetch` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  topics: {:array, [topic: :string, partitions: {:array, [partition: :int32]}]}\n]\n```","ref":"Kayrock.OffsetFetch.V2.Request.html"},{"type":"function","title":"Kayrock.OffsetFetch.V2.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetFetch.V2.Request.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetFetch.V2.Request.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.OffsetFetch.V2.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetFetch.V2.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.OffsetFetch.V2.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.OffsetFetch.V2.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetFetch.V2.Request.html#schema/0"},{"type":"function","title":"Kayrock.OffsetFetch.V2.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.OffsetFetch.V2.Request.html#serialize/1"},{"type":"type","title":"Kayrock.OffsetFetch.V2.Request.t/0","doc":"Request struct for the Kafka `offset_fetch` API v2","ref":"Kayrock.OffsetFetch.V2.Request.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetFetch.V2.Response","doc":"Kayrock-generated response struct for Kafka `offset_fetch` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition: :int32,\n        offset: :int64,\n        metadata: :nullable_string,\n        error_code: :int16\n      ]}\n   ]},\n  error_code: :int16\n]\n```","ref":"Kayrock.OffsetFetch.V2.Response.html"},{"type":"function","title":"Kayrock.OffsetFetch.V2.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetFetch.V2.Response.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetFetch.V2.Response.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.OffsetFetch.V2.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetFetch.V2.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.OffsetFetch.V2.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.OffsetFetch.V2.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetFetch.V2.Response.html#schema/0"},{"type":"type","title":"Kayrock.OffsetFetch.V2.Response.t/0","doc":"Response struct for the Kafka `offset_fetch` API v2","ref":"Kayrock.OffsetFetch.V2.Response.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetFetch.V3.Request","doc":"Kayrock-generated request struct for Kafka `offset_fetch` v3 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  topics: {:array, [topic: :string, partitions: {:array, [partition: :int32]}]}\n]\n```","ref":"Kayrock.OffsetFetch.V3.Request.html"},{"type":"function","title":"Kayrock.OffsetFetch.V3.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetFetch.V3.Request.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetFetch.V3.Request.api_vsn/0","doc":"Returns the API version (3) implemented by this module","ref":"Kayrock.OffsetFetch.V3.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetFetch.V3.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.OffsetFetch.V3.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.OffsetFetch.V3.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetFetch.V3.Request.html#schema/0"},{"type":"function","title":"Kayrock.OffsetFetch.V3.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.OffsetFetch.V3.Request.html#serialize/1"},{"type":"type","title":"Kayrock.OffsetFetch.V3.Request.t/0","doc":"Request struct for the Kafka `offset_fetch` API v3","ref":"Kayrock.OffsetFetch.V3.Request.html#t:t/0"},{"type":"module","title":"Kayrock.OffsetFetch.V3.Response","doc":"Kayrock-generated response struct for Kafka `offset_fetch` v3 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition: :int32,\n        offset: :int64,\n        metadata: :nullable_string,\n        error_code: :int16\n      ]}\n   ]},\n  error_code: :int16\n]\n```","ref":"Kayrock.OffsetFetch.V3.Response.html"},{"type":"function","title":"Kayrock.OffsetFetch.V3.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.OffsetFetch.V3.Response.html#api_key/0"},{"type":"function","title":"Kayrock.OffsetFetch.V3.Response.api_vsn/0","doc":"Returns the API version (3) implemented by this module","ref":"Kayrock.OffsetFetch.V3.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.OffsetFetch.V3.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.OffsetFetch.V3.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.OffsetFetch.V3.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.OffsetFetch.V3.Response.html#schema/0"},{"type":"type","title":"Kayrock.OffsetFetch.V3.Response.t/0","doc":"Response struct for the Kafka `offset_fetch` API v3","ref":"Kayrock.OffsetFetch.V3.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Produce","doc":"Kayrock-generated module for the Kafka `produce` API","ref":"Kayrock.Produce.html"},{"type":"function","title":"Kayrock.Produce.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.Produce.html#deserialize/2"},{"type":"function","title":"Kayrock.Produce.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.Produce.html#get_request_struct/1"},{"type":"function","title":"Kayrock.Produce.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (5)","ref":"Kayrock.Produce.html#max_vsn/0"},{"type":"function","title":"Kayrock.Produce.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.Produce.html#min_vsn/0"},{"type":"type","title":"Kayrock.Produce.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.Produce.html#t:request_t/0"},{"type":"type","title":"Kayrock.Produce.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.Produce.html#t:response_t/0"},{"type":"module","title":"Kayrock.Produce.V0.Request","doc":"Kayrock-generated request struct for Kafka `produce` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  acks: :int16,\n  timeout: :int32,\n  topic_data: {:array,\n   [topic: :string, data: {:array, [partition: :int32, record_set: :records]}]}\n]\n```","ref":"Kayrock.Produce.V0.Request.html"},{"type":"function","title":"Kayrock.Produce.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.Produce.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Produce.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Produce.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.Produce.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Produce.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Produce.V0.Request.t/0","doc":"Request struct for the Kafka `produce` API v0","ref":"Kayrock.Produce.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V0.Response","doc":"Kayrock-generated response struct for Kafka `produce` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [partition: :int32, error_code: :int16, base_offset: :int64]}\n   ]}\n]\n```","ref":"Kayrock.Produce.V0.Response.html"},{"type":"function","title":"Kayrock.Produce.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.Produce.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Produce.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Produce.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.Produce.V0.Response.t/0","doc":"Response struct for the Kafka `produce` API v0","ref":"Kayrock.Produce.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V1.Request","doc":"Kayrock-generated request struct for Kafka `produce` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  acks: :int16,\n  timeout: :int32,\n  topic_data: {:array,\n   [topic: :string, data: {:array, [partition: :int32, record_set: :records]}]}\n]\n```","ref":"Kayrock.Produce.V1.Request.html"},{"type":"function","title":"Kayrock.Produce.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.Produce.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Produce.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Produce.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.Produce.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Produce.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Produce.V1.Request.t/0","doc":"Request struct for the Kafka `produce` API v1","ref":"Kayrock.Produce.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V1.Response","doc":"Kayrock-generated response struct for Kafka `produce` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [partition: :int32, error_code: :int16, base_offset: :int64]}\n   ]},\n  throttle_time_ms: :int32\n]\n```","ref":"Kayrock.Produce.V1.Response.html"},{"type":"function","title":"Kayrock.Produce.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.Produce.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Produce.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Produce.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.Produce.V1.Response.t/0","doc":"Response struct for the Kafka `produce` API v1","ref":"Kayrock.Produce.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V2.Request","doc":"Kayrock-generated request struct for Kafka `produce` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  acks: :int16,\n  timeout: :int32,\n  topic_data: {:array,\n   [topic: :string, data: {:array, [partition: :int32, record_set: :records]}]}\n]\n```","ref":"Kayrock.Produce.V2.Request.html"},{"type":"function","title":"Kayrock.Produce.V2.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V2.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V2.Request.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.Produce.V2.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V2.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Produce.V2.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Produce.V2.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V2.Request.html#schema/0"},{"type":"function","title":"Kayrock.Produce.V2.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Produce.V2.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Produce.V2.Request.t/0","doc":"Request struct for the Kafka `produce` API v2","ref":"Kayrock.Produce.V2.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V2.Response","doc":"Kayrock-generated response struct for Kafka `produce` v2 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition: :int32,\n        error_code: :int16,\n        base_offset: :int64,\n        log_append_time: :int64\n      ]}\n   ]},\n  throttle_time_ms: :int32\n]\n```","ref":"Kayrock.Produce.V2.Response.html"},{"type":"function","title":"Kayrock.Produce.V2.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V2.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V2.Response.api_vsn/0","doc":"Returns the API version (2) implemented by this module","ref":"Kayrock.Produce.V2.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V2.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Produce.V2.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Produce.V2.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V2.Response.html#schema/0"},{"type":"type","title":"Kayrock.Produce.V2.Response.t/0","doc":"Response struct for the Kafka `produce` API v2","ref":"Kayrock.Produce.V2.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V3.Request","doc":"Kayrock-generated request struct for Kafka `produce` v3 API\nmessages\n\nThe schema of this API is\n```\n[\n  transactional_id: :nullable_string,\n  acks: :int16,\n  timeout: :int32,\n  topic_data: {:array,\n   [topic: :string, data: {:array, [partition: :int32, record_set: :records]}]}\n]\n```","ref":"Kayrock.Produce.V3.Request.html"},{"type":"function","title":"Kayrock.Produce.V3.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V3.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V3.Request.api_vsn/0","doc":"Returns the API version (3) implemented by this module","ref":"Kayrock.Produce.V3.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V3.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Produce.V3.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Produce.V3.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V3.Request.html#schema/0"},{"type":"function","title":"Kayrock.Produce.V3.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Produce.V3.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Produce.V3.Request.t/0","doc":"Request struct for the Kafka `produce` API v3","ref":"Kayrock.Produce.V3.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V3.Response","doc":"Kayrock-generated response struct for Kafka `produce` v3 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition: :int32,\n        error_code: :int16,\n        base_offset: :int64,\n        log_append_time: :int64\n      ]}\n   ]},\n  throttle_time_ms: :int32\n]\n```","ref":"Kayrock.Produce.V3.Response.html"},{"type":"function","title":"Kayrock.Produce.V3.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V3.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V3.Response.api_vsn/0","doc":"Returns the API version (3) implemented by this module","ref":"Kayrock.Produce.V3.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V3.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Produce.V3.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Produce.V3.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V3.Response.html#schema/0"},{"type":"type","title":"Kayrock.Produce.V3.Response.t/0","doc":"Response struct for the Kafka `produce` API v3","ref":"Kayrock.Produce.V3.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V4.Request","doc":"Kayrock-generated request struct for Kafka `produce` v4 API\nmessages\n\nThe schema of this API is\n```\n[\n  transactional_id: :nullable_string,\n  acks: :int16,\n  timeout: :int32,\n  topic_data: {:array,\n   [topic: :string, data: {:array, [partition: :int32, record_set: :records]}]}\n]\n```","ref":"Kayrock.Produce.V4.Request.html"},{"type":"function","title":"Kayrock.Produce.V4.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V4.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V4.Request.api_vsn/0","doc":"Returns the API version (4) implemented by this module","ref":"Kayrock.Produce.V4.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V4.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Produce.V4.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Produce.V4.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V4.Request.html#schema/0"},{"type":"function","title":"Kayrock.Produce.V4.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Produce.V4.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Produce.V4.Request.t/0","doc":"Request struct for the Kafka `produce` API v4","ref":"Kayrock.Produce.V4.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V4.Response","doc":"Kayrock-generated response struct for Kafka `produce` v4 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition: :int32,\n        error_code: :int16,\n        base_offset: :int64,\n        log_append_time: :int64\n      ]}\n   ]},\n  throttle_time_ms: :int32\n]\n```","ref":"Kayrock.Produce.V4.Response.html"},{"type":"function","title":"Kayrock.Produce.V4.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V4.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V4.Response.api_vsn/0","doc":"Returns the API version (4) implemented by this module","ref":"Kayrock.Produce.V4.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V4.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Produce.V4.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Produce.V4.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V4.Response.html#schema/0"},{"type":"type","title":"Kayrock.Produce.V4.Response.t/0","doc":"Response struct for the Kafka `produce` API v4","ref":"Kayrock.Produce.V4.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V5.Request","doc":"Kayrock-generated request struct for Kafka `produce` v5 API\nmessages\n\nThe schema of this API is\n```\n[\n  transactional_id: :nullable_string,\n  acks: :int16,\n  timeout: :int32,\n  topic_data: {:array,\n   [topic: :string, data: {:array, [partition: :int32, record_set: :records]}]}\n]\n```","ref":"Kayrock.Produce.V5.Request.html"},{"type":"function","title":"Kayrock.Produce.V5.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V5.Request.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V5.Request.api_vsn/0","doc":"Returns the API version (5) implemented by this module","ref":"Kayrock.Produce.V5.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V5.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.Produce.V5.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.Produce.V5.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V5.Request.html#schema/0"},{"type":"function","title":"Kayrock.Produce.V5.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.Produce.V5.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Produce.V5.Request.t/0","doc":"Request struct for the Kafka `produce` API v5","ref":"Kayrock.Produce.V5.Request.html#t:t/0"},{"type":"module","title":"Kayrock.Produce.V5.Response","doc":"Kayrock-generated response struct for Kafka `produce` v5 API\nmessages\n\nThe schema of this API is\n```\n[\n  responses: {:array,\n   [\n     topic: :string,\n     partition_responses: {:array,\n      [\n        partition: :int32,\n        error_code: :int16,\n        base_offset: :int64,\n        log_append_time: :int64,\n        log_start_offset: :int64\n      ]}\n   ]},\n  throttle_time_ms: :int32\n]\n```","ref":"Kayrock.Produce.V5.Response.html"},{"type":"function","title":"Kayrock.Produce.V5.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.Produce.V5.Response.html#api_key/0"},{"type":"function","title":"Kayrock.Produce.V5.Response.api_vsn/0","doc":"Returns the API version (5) implemented by this module","ref":"Kayrock.Produce.V5.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.Produce.V5.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.Produce.V5.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.Produce.V5.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.Produce.V5.Response.html#schema/0"},{"type":"type","title":"Kayrock.Produce.V5.Response.t/0","doc":"Response struct for the Kafka `produce` API v5","ref":"Kayrock.Produce.V5.Response.html#t:t/0"},{"type":"module","title":"Kayrock.RecordBatch","doc":"Represents a batch of records (also called a record set)\n\nThis is the newer format in Kafka 0.11+\n\nSee https://kafka.apache.org/documentation/#recordbatch","ref":"Kayrock.RecordBatch.html"},{"type":"function","title":"Kayrock.RecordBatch.deserialize/1","doc":"Direct deserializer\nSupplied for compatibility with the Request protocol","ref":"Kayrock.RecordBatch.html#deserialize/1"},{"type":"function","title":"Kayrock.RecordBatch.deserialize/2","doc":"","ref":"Kayrock.RecordBatch.html#deserialize/2"},{"type":"function","title":"Kayrock.RecordBatch.from_binary_list/2","doc":"","ref":"Kayrock.RecordBatch.html#from_binary_list/2"},{"type":"function","title":"Kayrock.RecordBatch.serialize/1","doc":"","ref":"Kayrock.RecordBatch.html#serialize/1"},{"type":"type","title":"Kayrock.RecordBatch.t/0","doc":"","ref":"Kayrock.RecordBatch.html#t:t/0"},{"type":"module","title":"Kayrock.RecordBatch.Record","doc":"Represents a single record (message)\n\nThis is the newer format in Kafka 0.11+\n\nSee https://kafka.apache.org/documentation/#recordbatch","ref":"Kayrock.RecordBatch.Record.html"},{"type":"type","title":"Kayrock.RecordBatch.Record.t/0","doc":"","ref":"Kayrock.RecordBatch.Record.html#t:t/0"},{"type":"module","title":"Kayrock.RecordBatch.RecordHeader","doc":"Represents a record header\n\nHeaders were added on Kafka 0.11+\n\nSee https://kafka.apache.org/documentation/#recordheader","ref":"Kayrock.RecordBatch.RecordHeader.html"},{"type":"type","title":"Kayrock.RecordBatch.RecordHeader.t/0","doc":"","ref":"Kayrock.RecordBatch.RecordHeader.html#t:t/0"},{"type":"module","title":"Kayrock.RenewDelegationToken","doc":"Kayrock-generated module for the Kafka `renew_delegation_token` API","ref":"Kayrock.RenewDelegationToken.html"},{"type":"function","title":"Kayrock.RenewDelegationToken.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.RenewDelegationToken.html#deserialize/2"},{"type":"function","title":"Kayrock.RenewDelegationToken.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.RenewDelegationToken.html#get_request_struct/1"},{"type":"function","title":"Kayrock.RenewDelegationToken.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.RenewDelegationToken.html#max_vsn/0"},{"type":"function","title":"Kayrock.RenewDelegationToken.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.RenewDelegationToken.html#min_vsn/0"},{"type":"type","title":"Kayrock.RenewDelegationToken.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.RenewDelegationToken.html#t:request_t/0"},{"type":"type","title":"Kayrock.RenewDelegationToken.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.RenewDelegationToken.html#t:response_t/0"},{"type":"module","title":"Kayrock.RenewDelegationToken.V0.Request","doc":"Kayrock-generated request struct for Kafka `renew_delegation_token` v0 API\nmessages\n\nThe schema of this API is\n```\n[hmac: :bytes, renew_time_period: :int64]\n```","ref":"Kayrock.RenewDelegationToken.V0.Request.html"},{"type":"function","title":"Kayrock.RenewDelegationToken.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.RenewDelegationToken.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.RenewDelegationToken.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.RenewDelegationToken.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.RenewDelegationToken.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.RenewDelegationToken.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.RenewDelegationToken.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.RenewDelegationToken.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.RenewDelegationToken.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.RenewDelegationToken.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.RenewDelegationToken.V0.Request.t/0","doc":"Request struct for the Kafka `renew_delegation_token` API v0","ref":"Kayrock.RenewDelegationToken.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.RenewDelegationToken.V0.Response","doc":"Kayrock-generated response struct for Kafka `renew_delegation_token` v0 API\nmessages\n\nThe schema of this API is\n```\n[error_code: :int16, expiry_timestamp: :int64, throttle_time_ms: :int32]\n```","ref":"Kayrock.RenewDelegationToken.V0.Response.html"},{"type":"function","title":"Kayrock.RenewDelegationToken.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.RenewDelegationToken.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.RenewDelegationToken.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.RenewDelegationToken.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.RenewDelegationToken.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.RenewDelegationToken.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.RenewDelegationToken.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.RenewDelegationToken.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.RenewDelegationToken.V0.Response.t/0","doc":"Response struct for the Kafka `renew_delegation_token` API v0","ref":"Kayrock.RenewDelegationToken.V0.Response.html#t:t/0"},{"type":"protocol","title":"Kayrock.Request","doc":"","ref":"Kayrock.Request.html"},{"type":"function","title":"Kayrock.Request.api_vsn/1","doc":"","ref":"Kayrock.Request.html#api_vsn/1"},{"type":"function","title":"Kayrock.Request.response_deserializer/1","doc":"","ref":"Kayrock.Request.html#response_deserializer/1"},{"type":"function","title":"Kayrock.Request.serialize/1","doc":"","ref":"Kayrock.Request.html#serialize/1"},{"type":"type","title":"Kayrock.Request.t/0","doc":"","ref":"Kayrock.Request.html#t:t/0"},{"type":"module","title":"Kayrock.SaslAuthenticate","doc":"Kayrock-generated module for the Kafka `sasl_authenticate` API","ref":"Kayrock.SaslAuthenticate.html"},{"type":"function","title":"Kayrock.SaslAuthenticate.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.SaslAuthenticate.html#deserialize/2"},{"type":"function","title":"Kayrock.SaslAuthenticate.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.SaslAuthenticate.html#get_request_struct/1"},{"type":"function","title":"Kayrock.SaslAuthenticate.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.SaslAuthenticate.html#max_vsn/0"},{"type":"function","title":"Kayrock.SaslAuthenticate.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.SaslAuthenticate.html#min_vsn/0"},{"type":"type","title":"Kayrock.SaslAuthenticate.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.SaslAuthenticate.html#t:request_t/0"},{"type":"type","title":"Kayrock.SaslAuthenticate.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.SaslAuthenticate.html#t:response_t/0"},{"type":"module","title":"Kayrock.SaslAuthenticate.V0.Request","doc":"Kayrock-generated request struct for Kafka `sasl_authenticate` v0 API\nmessages\n\nThe schema of this API is\n```\n[sasl_auth_bytes: :bytes]\n```","ref":"Kayrock.SaslAuthenticate.V0.Request.html"},{"type":"function","title":"Kayrock.SaslAuthenticate.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.SaslAuthenticate.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.SaslAuthenticate.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.SaslAuthenticate.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.SaslAuthenticate.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.SaslAuthenticate.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.SaslAuthenticate.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.SaslAuthenticate.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.SaslAuthenticate.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.SaslAuthenticate.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.SaslAuthenticate.V0.Request.t/0","doc":"Request struct for the Kafka `sasl_authenticate` API v0","ref":"Kayrock.SaslAuthenticate.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.SaslAuthenticate.V0.Response","doc":"Kayrock-generated response struct for Kafka `sasl_authenticate` v0 API\nmessages\n\nThe schema of this API is\n```\n[error_code: :int16, error_message: :nullable_string, sasl_auth_bytes: :bytes]\n```","ref":"Kayrock.SaslAuthenticate.V0.Response.html"},{"type":"function","title":"Kayrock.SaslAuthenticate.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.SaslAuthenticate.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.SaslAuthenticate.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.SaslAuthenticate.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.SaslAuthenticate.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.SaslAuthenticate.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.SaslAuthenticate.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.SaslAuthenticate.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.SaslAuthenticate.V0.Response.t/0","doc":"Response struct for the Kafka `sasl_authenticate` API v0","ref":"Kayrock.SaslAuthenticate.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.SaslHandshake","doc":"Kayrock-generated module for the Kafka `sasl_handshake` API","ref":"Kayrock.SaslHandshake.html"},{"type":"function","title":"Kayrock.SaslHandshake.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.SaslHandshake.html#deserialize/2"},{"type":"function","title":"Kayrock.SaslHandshake.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.SaslHandshake.html#get_request_struct/1"},{"type":"function","title":"Kayrock.SaslHandshake.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (1)","ref":"Kayrock.SaslHandshake.html#max_vsn/0"},{"type":"function","title":"Kayrock.SaslHandshake.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.SaslHandshake.html#min_vsn/0"},{"type":"type","title":"Kayrock.SaslHandshake.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.SaslHandshake.html#t:request_t/0"},{"type":"type","title":"Kayrock.SaslHandshake.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.SaslHandshake.html#t:response_t/0"},{"type":"module","title":"Kayrock.SaslHandshake.V0.Request","doc":"Kayrock-generated request struct for Kafka `sasl_handshake` v0 API\nmessages\n\nThe schema of this API is\n```\n[mechanism: :string]\n```","ref":"Kayrock.SaslHandshake.V0.Request.html"},{"type":"function","title":"Kayrock.SaslHandshake.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.SaslHandshake.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.SaslHandshake.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.SaslHandshake.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.SaslHandshake.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.SaslHandshake.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.SaslHandshake.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.SaslHandshake.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.SaslHandshake.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.SaslHandshake.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.SaslHandshake.V0.Request.t/0","doc":"Request struct for the Kafka `sasl_handshake` API v0","ref":"Kayrock.SaslHandshake.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.SaslHandshake.V0.Response","doc":"Kayrock-generated response struct for Kafka `sasl_handshake` v0 API\nmessages\n\nThe schema of this API is\n```\n[error_code: :int16, enabled_mechanisms: {:array, :string}]\n```","ref":"Kayrock.SaslHandshake.V0.Response.html"},{"type":"function","title":"Kayrock.SaslHandshake.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.SaslHandshake.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.SaslHandshake.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.SaslHandshake.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.SaslHandshake.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.SaslHandshake.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.SaslHandshake.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.SaslHandshake.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.SaslHandshake.V0.Response.t/0","doc":"Response struct for the Kafka `sasl_handshake` API v0","ref":"Kayrock.SaslHandshake.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.SaslHandshake.V1.Request","doc":"Kayrock-generated request struct for Kafka `sasl_handshake` v1 API\nmessages\n\nThe schema of this API is\n```\n[mechanism: :string]\n```","ref":"Kayrock.SaslHandshake.V1.Request.html"},{"type":"function","title":"Kayrock.SaslHandshake.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.SaslHandshake.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.SaslHandshake.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.SaslHandshake.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.SaslHandshake.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.SaslHandshake.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.SaslHandshake.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.SaslHandshake.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.SaslHandshake.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.SaslHandshake.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.SaslHandshake.V1.Request.t/0","doc":"Request struct for the Kafka `sasl_handshake` API v1","ref":"Kayrock.SaslHandshake.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.SaslHandshake.V1.Response","doc":"Kayrock-generated response struct for Kafka `sasl_handshake` v1 API\nmessages\n\nThe schema of this API is\n```\n[error_code: :int16, enabled_mechanisms: {:array, :string}]\n```","ref":"Kayrock.SaslHandshake.V1.Response.html"},{"type":"function","title":"Kayrock.SaslHandshake.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.SaslHandshake.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.SaslHandshake.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.SaslHandshake.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.SaslHandshake.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.SaslHandshake.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.SaslHandshake.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.SaslHandshake.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.SaslHandshake.V1.Response.t/0","doc":"Response struct for the Kafka `sasl_handshake` API v1","ref":"Kayrock.SaslHandshake.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.Serialize","doc":"Serializations for primitive types for the kafka protocol","ref":"Kayrock.Serialize.html"},{"type":"macro","title":"Kayrock.Serialize.primitive_types/0","doc":"","ref":"Kayrock.Serialize.html#primitive_types/0"},{"type":"function","title":"Kayrock.Serialize.serialize/2","doc":"","ref":"Kayrock.Serialize.html#serialize/2"},{"type":"function","title":"Kayrock.Serialize.serialize_array/2","doc":"","ref":"Kayrock.Serialize.html#serialize_array/2"},{"type":"module","title":"Kayrock.Socket","doc":"This module handle all socket related operations.\n\nNOTE this is a copy of KafkaEx.Socket:\nhttps://github.com/kafkaex/kafka_ex/blob/master/lib/kafka_ex/socket.ex\n\nIt is duplicated here to avoid creating a circular dependency.","ref":"Kayrock.Socket.html"},{"type":"function","title":"Kayrock.Socket.close/1","doc":"Closes the socket.\n\nFor more information, see `:ssl.close/1` for ssl or `:gen_tcp.send/1` for non ssl.","ref":"Kayrock.Socket.html#close/1"},{"type":"function","title":"Kayrock.Socket.create/4","doc":"Creates a socket.\n\nFor more information about the available options, see `:ssl.connect/3` for ssl\nor `:gen_tcp.connect/3` for non ssl.","ref":"Kayrock.Socket.html#create/4"},{"type":"function","title":"Kayrock.Socket.info/1","doc":"Returns the information about the socket.\n\nFor more information, see `Port.info`","ref":"Kayrock.Socket.html#info/1"},{"type":"function","title":"Kayrock.Socket.open?/1","doc":"Returns true if the socket is open","ref":"Kayrock.Socket.html#open?/1"},{"type":"function","title":"Kayrock.Socket.recv/2","doc":"Receives data from the socket.\n\nFor more information, see `:ssl.recv/2` for ssl or `:gen_tcp.recv/2` for non ssl.","ref":"Kayrock.Socket.html#recv/2"},{"type":"function","title":"Kayrock.Socket.recv/3","doc":"","ref":"Kayrock.Socket.html#recv/3"},{"type":"function","title":"Kayrock.Socket.send/2","doc":"Sends data over the socket.\n\nIt handles both, SSL and non SSL sockets.\n\nFor more information, see `:ssl.send/2` for ssl or `:gen_tcp.send/2` for non ssl.","ref":"Kayrock.Socket.html#send/2"},{"type":"function","title":"Kayrock.Socket.setopts/2","doc":"Set options to the socket.\n\nFor more information, see `:ssl.setopts/2` for ssl or `:inet.setopts/2` for non ssl.","ref":"Kayrock.Socket.html#setopts/2"},{"type":"type","title":"Kayrock.Socket.t/0","doc":"","ref":"Kayrock.Socket.html#t:t/0"},{"type":"module","title":"Kayrock.SyncGroup","doc":"Kayrock-generated module for the Kafka `sync_group` API","ref":"Kayrock.SyncGroup.html"},{"type":"function","title":"Kayrock.SyncGroup.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.SyncGroup.html#deserialize/2"},{"type":"function","title":"Kayrock.SyncGroup.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.SyncGroup.html#get_request_struct/1"},{"type":"function","title":"Kayrock.SyncGroup.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (1)","ref":"Kayrock.SyncGroup.html#max_vsn/0"},{"type":"function","title":"Kayrock.SyncGroup.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.SyncGroup.html#min_vsn/0"},{"type":"type","title":"Kayrock.SyncGroup.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.SyncGroup.html#t:request_t/0"},{"type":"type","title":"Kayrock.SyncGroup.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.SyncGroup.html#t:response_t/0"},{"type":"module","title":"Kayrock.SyncGroup.V0.Request","doc":"Kayrock-generated request struct for Kafka `sync_group` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  generation_id: :int32,\n  member_id: :string,\n  group_assignment: {:array, [member_id: :string, member_assignment: :bytes]}\n]\n```","ref":"Kayrock.SyncGroup.V0.Request.html"},{"type":"function","title":"Kayrock.SyncGroup.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.SyncGroup.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.SyncGroup.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.SyncGroup.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.SyncGroup.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.SyncGroup.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.SyncGroup.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.SyncGroup.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.SyncGroup.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.SyncGroup.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.SyncGroup.V0.Request.t/0","doc":"Request struct for the Kafka `sync_group` API v0","ref":"Kayrock.SyncGroup.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.SyncGroup.V0.Response","doc":"Kayrock-generated response struct for Kafka `sync_group` v0 API\nmessages\n\nThe schema of this API is\n```\n[error_code: :int16, member_assignment: :bytes]\n```","ref":"Kayrock.SyncGroup.V0.Response.html"},{"type":"function","title":"Kayrock.SyncGroup.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.SyncGroup.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.SyncGroup.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.SyncGroup.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.SyncGroup.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.SyncGroup.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.SyncGroup.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.SyncGroup.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.SyncGroup.V0.Response.t/0","doc":"Response struct for the Kafka `sync_group` API v0","ref":"Kayrock.SyncGroup.V0.Response.html#t:t/0"},{"type":"module","title":"Kayrock.SyncGroup.V1.Request","doc":"Kayrock-generated request struct for Kafka `sync_group` v1 API\nmessages\n\nThe schema of this API is\n```\n[\n  group_id: :string,\n  generation_id: :int32,\n  member_id: :string,\n  group_assignment: {:array, [member_id: :string, member_assignment: :bytes]}\n]\n```","ref":"Kayrock.SyncGroup.V1.Request.html"},{"type":"function","title":"Kayrock.SyncGroup.V1.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.SyncGroup.V1.Request.html#api_key/0"},{"type":"function","title":"Kayrock.SyncGroup.V1.Request.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.SyncGroup.V1.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.SyncGroup.V1.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.SyncGroup.V1.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.SyncGroup.V1.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.SyncGroup.V1.Request.html#schema/0"},{"type":"function","title":"Kayrock.SyncGroup.V1.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.SyncGroup.V1.Request.html#serialize/1"},{"type":"type","title":"Kayrock.SyncGroup.V1.Request.t/0","doc":"Request struct for the Kafka `sync_group` API v1","ref":"Kayrock.SyncGroup.V1.Request.html#t:t/0"},{"type":"module","title":"Kayrock.SyncGroup.V1.Response","doc":"Kayrock-generated response struct for Kafka `sync_group` v1 API\nmessages\n\nThe schema of this API is\n```\n[throttle_time_ms: :int32, error_code: :int16, member_assignment: :bytes]\n```","ref":"Kayrock.SyncGroup.V1.Response.html"},{"type":"function","title":"Kayrock.SyncGroup.V1.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.SyncGroup.V1.Response.html#api_key/0"},{"type":"function","title":"Kayrock.SyncGroup.V1.Response.api_vsn/0","doc":"Returns the API version (1) implemented by this module","ref":"Kayrock.SyncGroup.V1.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.SyncGroup.V1.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.SyncGroup.V1.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.SyncGroup.V1.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.SyncGroup.V1.Response.html#schema/0"},{"type":"type","title":"Kayrock.SyncGroup.V1.Response.t/0","doc":"Response struct for the Kafka `sync_group` API v1","ref":"Kayrock.SyncGroup.V1.Response.html#t:t/0"},{"type":"module","title":"Kayrock.TxnOffsetCommit","doc":"Kayrock-generated module for the Kafka `txn_offset_commit` API","ref":"Kayrock.TxnOffsetCommit.html"},{"type":"function","title":"Kayrock.TxnOffsetCommit.deserialize/2","doc":"Deserializes raw wire data for this API with the given version","ref":"Kayrock.TxnOffsetCommit.html#deserialize/2"},{"type":"function","title":"Kayrock.TxnOffsetCommit.get_request_struct/1","doc":"Returns a request struct for this API with the given version","ref":"Kayrock.TxnOffsetCommit.html#get_request_struct/1"},{"type":"function","title":"Kayrock.TxnOffsetCommit.max_vsn/0","doc":"Returns the maximum version of this API supported by Kayrock (0)","ref":"Kayrock.TxnOffsetCommit.html#max_vsn/0"},{"type":"function","title":"Kayrock.TxnOffsetCommit.min_vsn/0","doc":"Returns the minimum version of this API supported by Kayrock (0)","ref":"Kayrock.TxnOffsetCommit.html#min_vsn/0"},{"type":"type","title":"Kayrock.TxnOffsetCommit.request_t/0","doc":"Union type for all request structs for this API","ref":"Kayrock.TxnOffsetCommit.html#t:request_t/0"},{"type":"type","title":"Kayrock.TxnOffsetCommit.response_t/0","doc":"Union type for all response structs for this API","ref":"Kayrock.TxnOffsetCommit.html#t:response_t/0"},{"type":"module","title":"Kayrock.TxnOffsetCommit.V0.Request","doc":"Kayrock-generated request struct for Kafka `txn_offset_commit` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  transactional_id: :string,\n  group_id: :string,\n  producer_id: :int64,\n  producer_epoch: :int16,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array,\n      [partition: :int32, offset: :int64, metadata: :nullable_string]}\n   ]}\n]\n```","ref":"Kayrock.TxnOffsetCommit.V0.Request.html"},{"type":"function","title":"Kayrock.TxnOffsetCommit.V0.Request.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.TxnOffsetCommit.V0.Request.html#api_key/0"},{"type":"function","title":"Kayrock.TxnOffsetCommit.V0.Request.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.TxnOffsetCommit.V0.Request.html#api_vsn/0"},{"type":"function","title":"Kayrock.TxnOffsetCommit.V0.Request.response_deserializer/0","doc":"Returns a function that can be used to deserialize the wire response from the\nbroker for this message type","ref":"Kayrock.TxnOffsetCommit.V0.Request.html#response_deserializer/0"},{"type":"function","title":"Kayrock.TxnOffsetCommit.V0.Request.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.TxnOffsetCommit.V0.Request.html#schema/0"},{"type":"function","title":"Kayrock.TxnOffsetCommit.V0.Request.serialize/1","doc":"Serialize a message to binary data for transfer to a Kafka broker","ref":"Kayrock.TxnOffsetCommit.V0.Request.html#serialize/1"},{"type":"type","title":"Kayrock.TxnOffsetCommit.V0.Request.t/0","doc":"Request struct for the Kafka `txn_offset_commit` API v0","ref":"Kayrock.TxnOffsetCommit.V0.Request.html#t:t/0"},{"type":"module","title":"Kayrock.TxnOffsetCommit.V0.Response","doc":"Kayrock-generated response struct for Kafka `txn_offset_commit` v0 API\nmessages\n\nThe schema of this API is\n```\n[\n  throttle_time_ms: :int32,\n  topics: {:array,\n   [\n     topic: :string,\n     partitions: {:array, [partition: :int32, error_code: :int16]}\n   ]}\n]\n```","ref":"Kayrock.TxnOffsetCommit.V0.Response.html"},{"type":"function","title":"Kayrock.TxnOffsetCommit.V0.Response.api_key/0","doc":"Returns the Kafka API key for this API","ref":"Kayrock.TxnOffsetCommit.V0.Response.html#api_key/0"},{"type":"function","title":"Kayrock.TxnOffsetCommit.V0.Response.api_vsn/0","doc":"Returns the API version (0) implemented by this module","ref":"Kayrock.TxnOffsetCommit.V0.Response.html#api_vsn/0"},{"type":"function","title":"Kayrock.TxnOffsetCommit.V0.Response.deserialize/1","doc":"Deserialize data for this version of this API","ref":"Kayrock.TxnOffsetCommit.V0.Response.html#deserialize/1"},{"type":"function","title":"Kayrock.TxnOffsetCommit.V0.Response.schema/0","doc":"Returns the schema of this message\n\nSee [above](#).","ref":"Kayrock.TxnOffsetCommit.V0.Response.html#schema/0"},{"type":"type","title":"Kayrock.TxnOffsetCommit.V0.Response.t/0","doc":"Response struct for the Kafka `txn_offset_commit` API v0","ref":"Kayrock.TxnOffsetCommit.V0.Response.html#t:t/0"},{"type":"task","title":"mix gen.kafka_protocol","doc":"Mix task to generate the .ex files for each of the kafka protocol messages","ref":"Mix.Tasks.Gen.KafkaProtocol.html"},{"type":"function","title":"Mix.Tasks.Gen.KafkaProtocol.run/1","doc":"","ref":"Mix.Tasks.Gen.KafkaProtocol.html#run/1"},{"type":"exception","title":"Kayrock.ErrorCode.InvalidAtomException","doc":"Raised if `Kayrock.ErrorCode.atom_to_code!/1` is called with an atom that\ndoes not correspond to a known Kafka error code.","ref":"Kayrock.ErrorCode.InvalidAtomException.html"},{"type":"exception","title":"Kayrock.ErrorCode.InvalidErrorCodeException","doc":"Raised if `Kayrock.ErrorCode.code_to_atom!/1` is called with a code that\ndoes not correspond to a known Kafka error code.","ref":"Kayrock.ErrorCode.InvalidErrorCodeException.html"},{"type":"exception","title":"Kayrock.InvalidRequestError","doc":"Raised on serialization errors\n\nWe catch errors in the serialization code so that we can provide a more\nhelpful error message, including the original request struct","ref":"Kayrock.InvalidRequestError.html"},{"type":"extras","title":"Kayrock","doc":"# Kayrock\n\n[![CI Checks](https://github.com/kafkaex/kayrock/actions/workflows/checks.yml/badge.svg?branch=master)](https://github.com/kafkaex/kayrock/actions/workflows/checks.yml)\n[![CI Tests](https://github.com/kafkaex/kayrock/actions/workflows/test.yml/badge.svg?branch=master)](https://github.com/kafkaex/kayrock/actions/workflows/test.yml)\n[![Module Version](https://img.shields.io/hexpm/v/kayrock.svg)](https://hex.pm/packages/kayrock)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/kayrock/)\n[![Total Download](https://img.shields.io/hexpm/dt/kayrock.svg)](https://hex.pm/packages/kayrock)\n[![License](https://img.shields.io/hexpm/l/kayrock.svg)](https://hex.pm/packages/kayrock)\n[![Last Updated](https://img.shields.io/github/last-commit/dantswain/kayrock.svg)](https://github.com/dantswain/kayrock/commits/master)\n\nAims to provide an idiomatic Elixir interface to the Kafka protocol.\n\nThis work is based on [kafka_protocol](https://github.com/klarna/kafka_protocol)\nfor Erlang, which is used in [brod](https://github.com/klarna/brod).  It is\nbuilt to work with [KafkaEx](https://github.com/kafkaex/kafka_ex) though there\nis no reason why it couldn't be used elsewhere.","ref":"readme.html"},{"type":"extras","title":"Basic architecture and usage - Kayrock","doc":"Kayrock generates structs for every version of every message in the Kafka\nprotocol.  It does this by converting the Erlang-based schema descriptions in\n`:kpro_schema` from the `kafka_protocol` library and is therefore limited to\nmessages and versions included there.  Each request message has a serializer\n(that generates iodata), and each response message has a deserializer. There is\nalso a protocol, `Kayrock.Request`, that has an implementation created for each\nrequest.  The `Kayrock.Request` protocol defines a serializer as well as a\nresponse deserializer factory.\n\nThis repo includes a mix task, `mix gen.kafka_protocol`, that produces the code\nin `lib/generated`.  I chose to check the generated code into the repository to\nsimplify its use.  End users should not need to run the mix task unless they are\ndoing development on Kayrock itself.\n\nThe generated structs are namespaced as follows: `Kayrock. .V .[Request|Response]`.  For example, the version 4 fetch api corresponds\nto `Kayrock.Fetch.V4.Request` and `Kayrock.Fetch.V4.Response`.\n\nAn example of basic usage, taken (and modified) from\n`Kayrock.broker_sync_call/2`:\n\n```elixir\nalias Kayrock.Request\n\nrequest = %Kayrock.ApiVersions.V1.Request{client_id: \"some_client\", correlation_id: 0}\n\n# wire_protocol will be iodata representing the serialized request\nwire_protocol = Request.serialize(request)\n\n# implementation-specific network request/response handling\n:ok = BrokerConnection.send(broker_pid, wire_protocol)\n{:ok, resp} = BrokerConnection.recv(broker_pid)\n\n# response_deserializer will be a function that accepts binary data and\n# returns {%Kayrock.ApiVersions.V1.Response{}, rest} where rest is any\n# extra binary data in the response\nresponse_deserializer = Request.response_deserializer(request)\n{deserialized_resp, _} = response_deserializer.(resp)\n\n# deserialized_resp will be a %Kayrock.ApiVersions.V1.Response{} representing\n# the api versions supported by the broker\n```","ref":"readme.html#basic-architecture-and-usage"},{"type":"extras","title":"Messages Compression - Kayrock","doc":"Currently Kayrock is supporting two types of compression: snappy or gzip\n\nFor snappy compression by default will be used [snappy-erlang-nif](https://github.com/skunkwerks/snappy-erlang-nif) but this is \ndeprecated in favor for [snappyer](https://github.com/zmstone/snappyer) which is way more popular.\n\nTo change compression library change config from\n\n```elixir\n  config :kayrock, snappy_module: :snappy\n```\n\nto\n\n```elixir\n  config :kayrock, snappy_module: :snappyer\n```","ref":"readme.html#messages-compression"},{"type":"extras","title":"Relationship to other libraries - Kayrock","doc":"Kayrock uses only the `kpro_schema` module from `kafka_protocol`.\n`kafka_protocol` provides quite a lot of functionality (especially when used as\npart of `brod`).  This repo chooses to limit the integration surface between\nitself and `kafka_protocol` because\n\n1. `kafka_protocol` produces Erlang records whereas Kayrock aims to provide\n   Elixir structs.\n2. `kafka_protocol` provides network-level implementation whereas Kayrock is\n   intended to only provide serialization and deserialization of the protocol.\n3. `kpro_schema` is itself automatically generated from the Java source code of\n   Kafka, meaning that Kayrock could feasibly reproduce this without needing an\n   intermediate dependency.\n\nThis is in no way meant to detract from the great work that the\n`kafka_protocol`/`brod` team has done.  I have simply chosen a different path\nhere.\n\nYou will notice that in this repo there is also a lightweight implementation of\na Kafka client.  This serves a few purposes:\n\n1. To help with the development of the Kayrock protocol API.\n2. To allow for testing against a server without creating a circular dependency\n   on KafkaEx.\n3. Because I want to mess around with it.\n\nRegardless, it is not a production-ready implementation. I would refer you to\nKafkaEx or brod for that.","ref":"readme.html#relationship-to-other-libraries"},{"type":"extras","title":"Testing - Kayrock","doc":"Kayrock includes a test suite that checks that the generated code is correct.\nWe have both unit tests and integration tests.  \n\nThe unit tests are run as part of the normal mix test process. To run unit tests\n\n```shell\nmix test\n```\n\nThe integration tests require a running docker, currently we are using docker-compose to run a kafka cluster.\nBut we are in a process of migrating to use [testcontainers](https://github.com/testcontainers/testcontainers-elixir) \nto run kafka cluster.\n\nTo run original integration tests\n\n```shell\nmix test --include integration\n```\n\nTo run integration tests with testcontainers\n\n```shell\nmix test.integration\n```","ref":"readme.html#testing"}],"content_type":"text/markdown"}